//
//  CoinBonusSprite.m
//  DoodleDrop
//
//  Created by lai qing on 13-8-8.
//  Copyright 2013年 __MyCompanyName__. All rights reserved.
//

#import "CoinBonusSprite.h"


@implementation CoinBonusSprite

+(void) initAnimationAndSoundIntoCache
{
    CCAnimation *an = [CCAnimation animation];
    NSString *animationName = @"coin";
    NSArray *animateArray = [[NSArray alloc] initWithObjects:@"1",@"2",@"3",@"4",@"5",@"6",@"7",@"8",@"9", nil];
    for (NSString *frameNumber in animateArray) {
        NSString *animateFileName = [NSString stringWithFormat:@"%@%@.png",@"goldCoin",frameNumber];
        [an addSpriteFrameWithFilename:animateFileName];
        //[an addFrame:[[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:animateFileName]];
    }
    [an setDelayPerUnit:0.05f];
    an.restoreOriginalFrame = YES;
    //[an setDelay:0.5f];
    //最后加入到framecache
    [[CCAnimationCache sharedAnimationCache] addAnimation:an name:animationName];
    [animateArray release];
    
    [[SimpleAudioEngine sharedEngine] preloadEffect:@"coins.caf"];
}
-(void) initWithOwner:(CCLayer<AccelerationPos>*)owner inPosition:(CGPoint)position_ withSpriteBatchNode:(CCSpriteBatchNode *)_sb
{
    owner_ = owner;
    self.position = ccp(position_.x,position_.y);
    sb_ = _sb;
    scheduled = 0;
    system = nil;
    //animatename =
    
}

-(void) startAnimateAndSchedule
{
    [self playAnimation];
    //init schedule
    [self scheduleUpdate];
    scheduled = 1;
}


-(void) playAnimation
{
    CCAnimation *aniact = [[CCAnimationCache sharedAnimationCache] animationByName:@"coin"];
    CCAnimate *a1 = [CCAnimate actionWithAnimation:aniact];
    //CCAnimate *a1 = [CCAnimate actionWithDuration:1.0f animation:aniact restoreOriginalFrame:YES];
    CCRepeatForeverAnimation *rep = [CCRepeatForeverAnimation actionWithAction:a1];
    [self runAction:rep];
}

-(void) stopAnimation
{
    [self stopAllActions];
}

-(void) playParticleEffect
{
    [self stopAnimation];
    self.visible = NO;
    //system.positionType = kCCPositionTypeRelative;
    //释放粒子效果
    //system;
    
    system = [CCParticleSystemQuad particleWithFile:@"bonusParticle.plist"];
    system.position = ccp(self.position.x,self.position.y);
    system.duration = 0.5f;
    system.autoRemoveOnFinish =YES ;
    [owner_ addChild:system];
    
    [[SimpleAudioEngine sharedEngine] playEffect:@"coins.caf"];
    //[self removeChild:system cleanup:YES];
    
}

-(void) playAnimationEffect
{
    
}

-(void) resetHeight:(CGFloat)playerJumpMove
{
    self.position = ccp(self.position.x,self.position.y - playerJumpMove);
}

-(void) callbackFinish
{
    //CCLOG(@"coin callback finish : %@",self);
    [self stopAllActions];
    
    [owner_ releaseBonus:self];
    //[owner_ removeChild:self cleanup:YES];
}

-(void) update:(ccTime)delta
{
    //check collision with player
    //CCLOG(@"coin update...");
    int playerState = [owner_ getPlayerState];
    if (playerState == PLAYER_RESET_HEIGHT_STATE) return;
    
    CGRect playerRect = [owner_ returnPlayerBoundBox];
    //CGRect box = [self boundingBox];
    //if (CGRectIntersectsRect(playerRect, box)) {
    if (CGRectContainsPoint(playerRect, self.position)) {
        [self unscheduleUpdate];
        scheduled = 0;
        [self playParticleEffect];
        [self performSelector:@selector(callbackFinish) withObject:nil afterDelay:0.8f];
    }
    
    //check position y < 0
    if (self.position.y < 0) {
        [self unscheduleUpdate];
        scheduled = 0;
        [self callbackFinish];
    }
}

-(void) dealloc
{
    
    if (scheduled == 1) {
        [self stopAllActions];
        [self unscheduleUpdate];
    }
     
    //CCLOG(@"bonus release: %@",self);
    [super dealloc];
}

@end
