//
//  GameDefine.h
//  theLastNinja
//
//  Created by lai qing on 13-8-16.
//  Copyright (c) 2013年 Tide Studio Game. All rights reserved.
//

#ifndef theLastNinja_GameDefine_h
#define theLastNinja_GameDefine_h

#import <Foundation/Foundation.h>
#import "cocos2d.h"


#pragma mark -screenResoluation

#define IPHONE_3 1
#define IPOD_4 2
#define IPHONE_4 2
#define IPHONE_4S 2
#define IPHONE_5 3
#define IPOD_5 3
#define IPHONE_5C 3
#define IPHONE_5S 3

#define IPAD_1 10 //1024*768
#define IPAD_2 10 //1024*768
#define IPAD_3 11 //2048*1536
#define IPAD_4 11 //2048*1536
#define IPAD_MINI 10 //1024*768 no retina
#define IPAD_AIR 11 //2048*1536
#define IPAD_MINI_2 11 //2048*1536


#pragma mark -sceneID

#define MENU_SCENE 1
#define LOADING_SCENE 2
#define SELECT_GAME_TYPE_SCENE 3
#define OPTION_SCENE 4
#define SELECT_CHARACTER_SCENE 5
#define VIEW_CHARACTER_SCENE 6
#define SELECT_MAP_SCENE 7
#define GAME_OVER_SCENE 8

#define LANDSCRAPER_SCENE 10
#define FOREST_SCENE 11
#define VOLCANO_SCENE 12
#define ICEBERG_SCENE 13
#define BASE_SCENE 14

#define AUDIO_MAX_WAITTIME 150

#pragma mark SELCET_PLAYER_SCENE_SPRITE_ID

#define CHILD_TYPE_CCSPRITE 0
#define CHILD_TYPE_CCLABEL 1

#define BACKGROUND_0 100
#define BACKGROUND_1 101
#define BACKGROUND_2 102

#define BACKGROUND_3 103
#define BACKGROUND_4 104

#define MAP_BG_0 110
#define MAP_BG_1 111
#define MAP_BG_2 112
#define MAP_BG_3 113
#define MAP_BG_4 114

#define MAP_0 120
#define MAP_1 121
#define MAP_2 122
#define MAP_3 123
#define MAP_4 124

#define HEAD_BG_0 103
#define HEAD_BG_1 104
#define HEAD_BG_2 105

#define HEAD_0 106  //play repeat animation
#define HEAD_1 107  //play repeat animation
#define HEAD_2 108  //play repeat animation

#define INFO_BG_0 109
#define INFO_BG_1 110
#define INFO_BG_2 111

#define SKILL_BG_0 112
#define SKILL_BG_1 113
#define SKILL_BG_2 114
#define SKILL_BG_3 115
#define SKILL_BG_4 116
#define SKILL_BG_5 117
#define SKILL_BG_6 118
#define SKILL_BG_7 119
#define SKILL_BG_8 120
#define SKILL_BG_9 121
#define SKILL_BG_10 122
#define SKILL_BG_11 123
#define SKILL_BG_12 124
#define SKILL_BG_13 125
#define SKILL_BG_14 126

#define SKILL_0 127
#define SKILL_1 128
#define SKILL_2 129
#define SKILL_3 130
#define SKILL_4 131
#define SKILL_5 132
#define SKILL_6 133
#define SKILL_7 134
#define SKILL_8 135
#define SKILL_9 136
#define SKILL_10 137
#define SKILL_11 138
#define SKILL_12 139
#define SKILL_13 140
#define SKILL_14 141

#define DIALOG_0 142
#define DIALOG_1 143
#define DIALOG_2 144

#define GO_BACK_0 145
#define GO_BACK_1 146
#define GO_BACK_2 147

#define GO_NEXT_0 148
#define GO_NEXT_1 149
#define GO_NEXT_2 150

#define LEFT_BUTTON_0 151
#define LEFT_BUTTON_1 152
#define LEFT_BUTTON_2 153
#define RIGHT_BUTTON_0 154
#define RIGHT_BUTTON_1 155
#define RIGHT_BUTTON_2 156

#pragma mark SELCET_PLAYER_SCENE_TEXT_ID

#define TEXT_CHARACTER_NAME_0 200
#define TEXT_CHARACTER_NAME_1 201
#define TEXT_CHARACTER_NAME_2 202

#define TEXT_CHARACTER_LEVEL_0 203
#define TEXT_CHARACTER_HP_0 204
#define TEXT_CHARACTER_MP_0 205
#define TEXT_CHARACTER_ATTACK_0 206
#define TEXT_CHARACTER_DEFEND_0 207
#define TEXT_CHARACTER_EXP_0 208

#define TEXT_CHARACTER_LEVEL_1 209
#define TEXT_CHARACTER_HP_1 210
#define TEXT_CHARACTER_MP_1 211
#define TEXT_CHARACTER_ATTACK_1 212
#define TEXT_CHARACTER_DEFEND_1 213
#define TEXT_CHARACTER_EXP_1 214

#define TEXT_CHARACTER_LEVEL_2 215
#define TEXT_CHARACTER_HP_2 216
#define TEXT_CHARACTER_MP_2 217
#define TEXT_CHARACTER_ATTACK_2 218
#define TEXT_CHARACTER_DEFEND_2 219
#define TEXT_CHARACTER_EXP_2 220

#define TEXT_SKILL_NAME_0 221
#define TEXT_SKILL_NAME_1 222
#define TEXT_SKILL_NAME_2 223
#define TEXT_SKILL_NAME_3 224
#define TEXT_SKILL_NAME_4 225
#define TEXT_SKILL_NAME_5 226
#define TEXT_SKILL_NAME_6 227
#define TEXT_SKILL_NAME_7 228
#define TEXT_SKILL_NAME_8 229
#define TEXT_SKILL_NAME_9 230
#define TEXT_SKILL_NAME_10 231
#define TEXT_SKILL_NAME_11 232
#define TEXT_SKILL_NAME_12 233
#define TEXT_SKILL_NAME_13 234
#define TEXT_SKILL_NAME_14 235

#define TEXT_PLAYER_SKILL_LEVEL_0 270
#define TEXT_PLAYER_SKILL_LEVEL_1 271
#define TEXT_PLAYER_SKILL_LEVEL_2 272
#define TEXT_PLAYER_SKILL_LEVEL_3 273
#define TEXT_PLAYER_SKILL_LEVEL_4 274

#define TEXT_PLAYER_ITEM_0 275
#define TEXT_PLAYER_ITEM_1 276
#define TEXT_PLAYER_ITEM_2 277
#define TEXT_PLAYER_ITEM_3 278
#define TEXT_PLAYER_ITEM_4 279
#define TEXT_PLAYER_ITEM_5 280
#define TEXT_PLAYER_ITEM_6 281
#define TEXT_PLAYER_ITEM_7 282
#define TEXT_PLAYER_ITEM_8 283
#define TEXT_PLAYER_ITEM_9 284


#define TEXT_MESSAGES 299

//these descriptions below not create CCLabel
#define TEXT_CHARACTER_DESC_0 240
#define TEXT_CHARACTER_DESC_1 241
#define TEXT_CHARACTER_DESC_2 242

#define TEXT_SKILL_DESC_0 250
#define TEXT_SKILL_DESC_1 251
#define TEXT_SKILL_DESC_2 252
#define TEXT_SKILL_DESC_3 253
#define TEXT_SKILL_DESC_4 254
#define TEXT_SKILL_DESC_5 255
#define TEXT_SKILL_DESC_6 256
#define TEXT_SKILL_DESC_7 257
#define TEXT_SKILL_DESC_8 258
#define TEXT_SKILL_DESC_9 259
#define TEXT_SKILL_DESC_10 260
#define TEXT_SKILL_DESC_11 261
#define TEXT_SKILL_DESC_12 262
#define TEXT_SKILL_DESC_13 263
#define TEXT_SKILL_DESC_14 264

//text in the select map scene
#define TEXT_SCENE_NAME_0 300
#define TEXT_SCENE_NAME_1 301
#define TEXT_SCENE_NAME_2 302
#define TEXT_SCENE_NAME_3 303
#define TEXT_SCENE_NAME_4 304


//sprite in the main scene hud layer

#define SPRITE_HEAD_BACKGROUND 400
#define SPRITE_HEAD 401
#define SPRITE_HP 402
#define SPRITE_MP 403
#define TEXT_LEVEL 404
#define SPRITE_EQUIP_BTN 405
#define SPRITE_PAUSE_BTN 406
#define TEXT_JUMP_HEIGHT 407
#define TEXT_KILL_COUNT 408
#define TEXT_HIT_COUNT 409
#define SPRITE_SKILL_BTN_1 410
#define SPRITE_SKILL_BTN_2 411
#define SPRITE_ATTACK_BTN 412

#define Z_ORDER_BACKGROUND_LAYER 0
#define Z_ORDER_MAIN_LAYER 1
#define Z_ORDER_HUD_LAYER 2
#define Z_ORDER_EQUIP_LAYER 3
#define Z_ORDER_MENU_LAYER 4

//player state

#define PLAYER_WALK_STATE 0
#define PLAYER_JUMP_STATE 1
#define PLAYER_FALL_STATE 2
#define PLAYER_IDLE_STATE 3
#define PLAYER_ATTACK_STATE 4
#define PLAYER_BIG_ATTACK_STATE 5
#define PLAYER_HURT_STATE 6
#define PLAYER_HURT_ON_AIR_LEFT_STATE 7
#define PLAYER_HURT_ON_AIR_RIGHT_STATE 8
#define PLAYER_HURT_ON_AIR_FALL_STATE 9
#define PLAYER_DEAD_STATE 10
#define PLAYER_RESET_HEIGHT_STATE 11


#define SPRITE_ENEMYBOT_BATCH_NODE_ID 1  //for the game main layer child id for CCSpriteBatchNode , which include bullet/barret/bonus/bot etc
#define SPRITE_PLAYER_NODE_ID 2          //for the game main layer player child id

typedef enum {
    kAudioManagerUninitialized=0,
    kAudioManagerFailed=1,
    kAudioManagerInitializing=2,
    kAudioManagerInitialized=100,
    kAudioManagerLoading=200,
    kAudioManagerReady=300
    
} GameManagerSoundState;

//单独一个存盘文件，用于显示玩家是否已经解锁了其他角色，以及场景等。
typedef struct scene_record {
    BOOL character_unlocked[3];
    BOOL scene_unlocked[5];
} sceneRecord;

//item 0 - 9 , 0: heal potion, mp potion, fire/ice/electr/poison state potion, fire/ice/elec/poison resist potion
typedef struct player_record {
    
    int useMusic;
    int useEffect;
    int showTutorial;
    
    int player_id; //0 , role 1 , 1 role 2 , 2 role 3
    int level;
    int hp;
    int hpMax;
    int mp;
    int mpMax;
    int experience;
    int attack;
    int defend;
    long long money;
    int item0;
    int item1;
    int item2;
    int item3;
    int item4;
    int item5;
    int item6;
    int item7;
    int item8;
    int item9;
    int skill0;
    int skill1;
    int skill2;
    int skill3;
    int skill4;
} playerRecord;




#endif
