//
//  GameMainLayer.h
//  theLastNinja
//
//  Created by lai qing on 13-11-6.
//  Copyright 2013年 Tide Studio Game. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "cocos2d.h"
#import "GameDefine.h"
#import "ShareGameObjectManager.h"
#import "JumpProtocol.h"
#import "SwordManSprite.h"

@interface GameMainLayer : CCLayer<AccelerationPos> {
    int sceneID;  //change enemy level png from different scene
    
    SwordManSprite* player;
	CGPoint playerVelocity;
    CGPoint newpos;
    
    ALuint currentEffectID;
    
    CCArray *levels;
    CCArray *enemys;
    CCArray *bonus;
    CCArray *bullets;
    CCArray* levelsNeedToRemove;
    
    CCSpriteBatchNode *sb ;
    
    CCParticleSystem *system;
	
	
    CGFloat deltaY;  //during jumping
    CGFloat lastPositionY;
    
    BOOL isGameOver;
    int ccfo;
    
}

+(id) nodeWithSceneID:(int)scID;
-(id) initWithSceneID:(int)scID;

-(void) enableAccAndUpdate;

-(void) changeJumpingState:(NSNumber*)_code;
-(void) playerResetFrame:(id)emptyparam ;

-(CGPoint) returnPlayerPos;
-(CGRect) returnPlayerBoundBox;
-(void) setDeltaY:(CGFloat)dy;      //need in the CCFalling Action
-(void) setPlayerState:(int)state;  //need in the CCFalling Action
-(int) getPlayerState;              //need in the CCFalling Action

-(CCSprite<PlayerRole>*) returnPlayerRole;

-(void) addEnemy:(CCSprite*)enemy;
-(void) releaseEnemy:(CCSprite*)enemy;
-(CCArray*) getEnemyList;

-(void) addBonus:(CCSprite*)bo;
-(void) releaseBonus:(CCSprite*)bo;
-(CCArray*) getBonusList;

@end
