//
//  GameMainMenuLayer.m
//  theLastNinja
//
//  Created by lai qing on 13-11-6.
//  Copyright 2013年 Tide Studio Game. All rights reserved.
//

#import "GameMainMenuLayer.h"


@implementation GameMainMenuLayer

-(id) init
{
    if ((self = [super init])) {
        //add five option , resume , music , sound , tutorial , exit
        int scr = [[ShareGameObjectManager shareGameObjectManager] getScreenResolution];
        if (scr < 10) {
            //iphone serial
            [self initMenuForIphone];
        }
        else {
            //ipad serial
            [self initMenuForIpad];
        }
        [[[CCDirector sharedDirector] touchDispatcher] addTargetedDelegate:self priority:0 swallowsTouches:YES];
    }
    
    return self;
}

- (BOOL)ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event
{
    return YES;
}

- (void)ccTouchEnded:(UITouch *)touch withEvent:(UIEvent *)event {
    //do nothing
}

-(void) cleanup
{
    [[[CCDirector sharedDirector] touchDispatcher] removeDelegate:self];
    [super cleanup];
}

-(void) initMenuForIphone
{
    CCSprite* bg = [CCSprite spriteWithFile:@"mapbg.png"];
    CGSize size = [[CCDirector sharedDirector] winSize];
    bg.position = ccp(size.width/2,size.height/2);
    [self addChild:bg z:0];
    
    //
    int music = [[ShareGameObjectManager shareGameObjectManager] getMusic];
    music_btn = [CCMenuItemImage itemWithNormalImage:@"button.png" selectedImage:@"button.png" target:self selector:@selector(changeMusic)];
    music_btn.scale = 0.5f;
    if (music == 1) {
        music_font = [CCLabelBMFont labelWithString:@"music on" fntFile:@"ninja-casual.fnt"];
    }
    else {
        music_font = [CCLabelBMFont labelWithString:@"music off" fntFile:@"ninja-casual.fnt"];
    }
    music_font.position = ccp(size.width/2,size.height/2+104);
    music_font.scale = 0.5f;
    [self addChild:music_font z:2];
    int sound = [[ShareGameObjectManager shareGameObjectManager] getSound];
    sound_btn = [CCMenuItemImage itemWithNormalImage:@"button.png" selectedImage:@"button.png" target:self selector:@selector(changeSound)];
    sound_btn.scale = 0.5f;
    if (sound == 1) {
        sound_font = [CCLabelBMFont labelWithString:@"sound on" fntFile:@"ninja-casual.fnt"];
    }
    else {
        sound_font = [CCLabelBMFont labelWithString:@"sound off" fntFile:@"ninja-casual.fnt"];
    }
    sound_font.position = ccp(size.width/2,size.height/2+52);
    sound_font.scale = 0.5f;
    [self addChild:sound_font z:2];
    
    int tutorial = [[ShareGameObjectManager shareGameObjectManager] getTutorial];
    tutorial_btn = [CCMenuItemImage itemWithNormalImage:@"button.png" selectedImage:@"button.png" target:self selector:@selector(changeTutorial)];
    tutorial_btn.scale = 0.5f;
    if (tutorial == 1) {
        tutorial_font = [CCLabelBMFont labelWithString:@"tutorial on" fntFile:@"ninja-casual.fnt"];
    }
    else {
        tutorial_font = [CCLabelBMFont labelWithString:@"tutorial off" fntFile:@"ninja-casual.fnt"];
    }
    tutorial_font.position = ccp(size.width/2,size.height/2);
    tutorial_font.scale = 0.5f;
    [self addChild:tutorial_font z:2];
    
    CCLabelBMFont* resume_font = [CCLabelBMFont labelWithString:@"resume" fntFile:@"ninja-casual.fnt"];
    resume_font.position = ccp(size.width/2,size.height/2-52);
    resume_font.scale = 0.5f;
    [self addChild:resume_font z:2];
    
    resume_btn = [CCMenuItemImage itemWithNormalImage:@"button.png" selectedImage:@"button.png" target:self selector:@selector(resumeGame)];
    resume_btn.scale = 0.5f;
    
    CCLabelBMFont* quit_font = [CCLabelBMFont labelWithString:@"quit" fntFile:@"ninja-casual.fnt"];
    quit_font.position = ccp(size.width/2,size.height/2-104);
    quit_font.scale = 0.5f;
    [self addChild:quit_font z:2];
    
    quit_btn = [CCMenuItemImage itemWithNormalImage:@"button.png" selectedImage:@"button.png" target:self selector:@selector(quit)];
    quit_btn.scale = 0.5f;
    
    CCMenu *menu = [CCMenu menuWithItems:music_btn,sound_btn,tutorial_btn, resume_btn, quit_btn, nil];
    
    //[menu alignItemsVertically];
    [menu alignItemsVerticallyWithPadding:25];
    [menu setPosition:ccp( size.width/2, size.height/2)];
    [self addChild:menu z:1];

}

-(void) initMenuForIpad
{
    
}

-(void) resumeGame
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    //todo: resume the main layer schedule
    
    //self close
    [self removeFromParentAndCleanup:YES];
    //[self release];
}

-(void) quit
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    [[ShareGameObjectManager shareGameObjectManager] runSceneWithID:MENU_SCENE withLoadingNextScene:0];
}

-(void) changeMusic
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    int imusic = [[ShareGameObjectManager shareGameObjectManager] getMusic];
    int nmusic = 0;
    if (imusic == 0) {
        nmusic = 1;
    }
    else {
        nmusic = 0;
    }
    [[ShareGameObjectManager shareGameObjectManager] setMusic:nmusic];
    //change font and image
    nmusic == 1? [music_font setString:@"music on"] : [music_font setString:@"music off"];
    
}

-(void) changeSound
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    int isound = [[ShareGameObjectManager shareGameObjectManager] getSound];
    int nsound = 0;
    if (isound == 0) {
        nsound = 1;
    }
    else {
        nsound = 0;
    }
    [[ShareGameObjectManager shareGameObjectManager] setSound:nsound];
    //change font and image
    nsound == 1? [sound_font setString:@"sound on"] : [sound_font setString:@"sound off"];
}

-(void) changeTutorial
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    //change sharegamemanager instance var , change playrecinfo , set the string to the oppsite word
    int iton = [[ShareGameObjectManager shareGameObjectManager] getTutorial];
    int nton = 0;
    if (iton == 0) {
        nton = 1;
    }
    else {
        nton = 0;
    }
    [[ShareGameObjectManager shareGameObjectManager] setTurtorial:nton];
    //change font and image
    nton == 1? [tutorial_font setString:@"tutorial on"] : [tutorial_font setString:@"tutorial off"];
}

@end
