//
//  HelloWorldLayer.m
//  theLastNinja
//
//  Created by lai qing on 13-8-15.
//  Copyright Tide Studio Game 2013年. All rights reserved.
//


// Import the interfaces
#import "GameMenuLayer.h"

// Needed to obtain the Navigation Controller
#import "AppDelegate.h"

#import "ShareGameObjectManager.h"

#pragma mark - HelloWorldLayer

// HelloWorldLayer implementation
@implementation GameMenuLayer



// on "init" you need to initialize your instance
-(id) init
{
	// always call "super" init
	// Apple recommends to re-assign "self" with the "super's" return value
	if( (self=[super init]) ) {
		
		//set background image
        CCSprite* bg = [CCSprite spriteWithFile:@"background.png"];
        bg.anchorPoint = ccp(0,0);
        bg.position = ccp(0,0);
        [self addChild:bg z:-1];
		
		
		// Default font size will be 28 points.
		[CCMenuItemFont setFontSize:20];
		
		// to avoid a retain-cycle with the menuitem and blocks
		__block id copy_self = self;
		
        CCLabelBMFont* startFont = [CCLabelBMFont labelWithString:@"start" fntFile:@"ninja-casual.fnt"];
        CCMenuItemLabel* startLabel = [CCMenuItemLabel itemWithLabel:startFont target:self selector:@selector(startGame)];
        
        //CCMenuItem *start = [CCMenuItemFont itemWithString:@"Start" target:self selector:@selector(startGame)];
        
        
        CCLabelBMFont* gcFont = [CCLabelBMFont labelWithString:@"Game Center" fntFile:@"ninja-casual.fnt"];
        CCMenuItemLabel* gcLabel = [CCMenuItemLabel itemWithLabel:gcFont block:^(id sender) {
			GKLeaderboardViewController *leaderboardViewController = [[GKLeaderboardViewController alloc] init];
			leaderboardViewController.leaderboardDelegate = copy_self;
			AppController *app = (AppController*) [[UIApplication sharedApplication] delegate];
			[[app navController] presentModalViewController:leaderboardViewController animated:YES];
			[leaderboardViewController release];
		}];
        
        CCLabelBMFont* optionFont = [CCLabelBMFont labelWithString:@"option" fntFile:@"ninja-casual.fnt"];
        CCMenuItemLabel* optionLabel = [CCMenuItemLabel itemWithLabel:optionFont target:self selector:@selector(showOption)];
        
		CCMenu *menu = [CCMenu menuWithItems:startLabel,gcLabel,optionLabel, nil];
        //[menu alignItemsVertically];
        [menu alignItemsVerticallyWithPadding:20];
		
		//[menu alignItemsHorizontallyWithPadding:20];
        CGSize size = [[CCDirector sharedDirector] winSize];
        
		[menu setPosition:ccp( size.width/2+50, size.height/2 - 80)];
		
		// Add the menu to the layer
		[self addChild:menu];
        
        // Add facebook , twitter
        fb = [TouchAbleSprite spriteWithFile:@"facebook.png"];
        [fb initLayer:self withSelector:@selector(gotoFacebook) defaultImageFile:@"facebook.png" pressImageFile:@"facebook.png" imageInCache:NO];
        fb.position = ccp(20,20);
        [self addChild:fb z:1];
        
        tw = [TouchAbleSprite spriteWithFile:@"twitter.png"];
        [tw initLayer:self withSelector:@selector(gotoTwitter) defaultImageFile:@"twitter.png" pressImageFile:@"twitter.png" imageInCache:NO];
        tw.position = ccp(60,20);
        [self addChild:tw z:1];
        
        
        

	}
	return self;
}

-(void) onEnter {
    //preload and run back music
    [[SimpleAudioEngine sharedEngine] preloadBackgroundMusic:@"logo.aifc"];
    [[SimpleAudioEngine sharedEngine] preloadEffect:@"menutouch.caf"];
    if ([[ShareGameObjectManager shareGameObjectManager] getMusic]) {
        [[ShareGameObjectManager shareGameObjectManager] playBackgroundTrack:@"logo.aifc"];
    }
    [super onEnter];
}


-(void) startGame {
    //check if there exist record , show continue button , and show delete button , else show new game button.
    //go to the SelectGameLayer
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    [[ShareGameObjectManager shareGameObjectManager] runSceneWithID:SELECT_GAME_TYPE_SCENE withLoadingNextScene:0];
}

-(void) showOption {
    //load from user default setting , to find the music , sound effect , tutorial on.
    //go to the game option layer
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    [[ShareGameObjectManager shareGameObjectManager] runSceneWithID:OPTION_SCENE withLoadingNextScene:0];
}

-(void) gotoFacebook
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    NSString* furl = @"http://facebook.com/tidestudio";
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:furl]];
}

-(void) gotoTwitter
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    NSString* turl = @"http://twitter.com/intent/user?screen_name=tidestudio";
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:turl]];
}


// on "dealloc" you need to release all your retained objects
- (void) dealloc
{
	// in case you have something to dealloc, do it in this method
	// in this particular example nothing needs to be released.
	// cocos2d will automatically release all the children (Label)
	
	// don't forget to call "super dealloc"
	[super dealloc];
}

#pragma mark GameKit delegate


-(void) leaderboardViewControllerDidFinish:(GKLeaderboardViewController *)viewController
{
	AppController *app = (AppController*) [[UIApplication sharedApplication] delegate];
	[[app navController] dismissModalViewControllerAnimated:YES];
}
@end
