//
//  LevelSprite.m
//  DoodleDrop
//
//  Created by lai qing on 13-7-31.
//  Copyright 2013年 __MyCompanyName__. All rights reserved.
//

#import "LevelSprite.h"


@implementation LevelSprite

-(void) initWithOwner:(CCLayer<AccelerationPos>*)owner inPosition:(CGPoint)position_ withSpriteBatchNode:(CCSpriteBatchNode*)_sb
{
    owner_ = owner;
    self.position = ccp(position_.x,position_.y);
    sb_ = _sb;
}

-(CGPoint) walkingRangeLeft
{
    CGFloat posx = self.position.x - self.contentSize.width/2 ;
    CGFloat posy = self.position.y ;
    CGPoint pos = ccp(posx,posy);
    return pos;
}

-(CGPoint) walkingRangeRight
{
    CGFloat posx = self.position.x + self.contentSize.width/2 ;
    CGFloat posy = self.position.y ;
    CGPoint pos = ccp(posx,posy);
    return pos;
}

-(void) generateHurtObject
{
    //generate once hurt to player on it , call player.recvHurt() the hurtObject no need to check collision in CGRectInterRect
}

-(void) generateObstacle
{
    
}

-(void) noticeBotRelease
{
    botOnIt_ = nil; 
}

-(void) generateEnemyBot  //generate enemybot and set it's enemybot property
{
    int rate = arc4random()%10;
    if (rate >= 4) {
        botOnIt_ = nil;
        //generate bonus
        CoinBonusSprite *cbsp = [CoinBonusSprite spriteWithSpriteFrameName:@"goldCoin1.png"];
        [cbsp initWithOwner:owner_ inPosition:ccp(self.position.x,self.position.y+30) withSpriteBatchNode:sb_];
        [owner_ addBonus:cbsp];
        [cbsp startAnimateAndSchedule];
        return;
    }
    //add enemy now
    //bot = [[SKSprite alloc] initWithSpriteFrame:[[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:@"s00.png"]];
    botOnIt_ = [SKSprite spriteWithSpriteFrameName:@"s00.png"];
    [botOnIt_ initBatchSpriteNode:sb_ withOwnerLayer:owner_ withLevel:self];
    [botOnIt_ initAllStateWithPlayerDefend:10 playerLevel:2];
    botOnIt_.flipX = NO;
    botOnIt_.visible = YES;
    botOnIt_.position = ccp(self.position.x-self.contentSize.width/2 , self.position.y + self.contentSize.height/2 + botOnIt_.contentSize.height/2 - 10);
    [owner_ addEnemy:botOnIt_];
    //[sb_ addChild:botOnIt_ z:-1];
}

-(void) update:(ccTime)delta
{
    //check if roll out of screen , then notice the owner to release self , then dealloc self
    
}

-(void) dealloc
{
    if (botOnIt_ != nil) {
        [botOnIt_ callbackFinish];
    }
    [super dealloc];
}

@end
