//
//  IntroLayer.m
//  theLastNinja
//
//  Created by lai qing on 13-8-15.
//  Copyright Tide Studio Game 2013年. All rights reserved.
//


// Import the interfaces
#import "LoadingLayer.h"
#import "GameMenuLayer.h"


#pragma mark - IntroLayer

// HelloWorldLayer implementation
@implementation LoadingLayer

// Helper class method that creates a Scene with the HelloWorldLayer as the only child.
+(CCScene *) scene:(int)sceneID
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	LoadingLayer *layer = [LoadingLayer node];
    
    [layer setNextScene:sceneID];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

// 
-(id) init
{
	if( (self=[super init])) {

		// ask director for the window size
		CGSize size = [[CCDirector sharedDirector] winSize];

		CCSprite *background;
		
		if( UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone ) {
			background = [CCSprite spriteWithFile:@"loading.png"];
			//background.rotation = 90;
		} else {
			background = [CCSprite spriteWithFile:@"loading.png"];
		}
		background.position = ccp(size.width/2, size.height/2);

		// add the label as a child to this Layer
		[self addChild: background];
	}
	
	return self;
}



-(id) initWithNextSceneID:(int)sceneID
{
    if( (self=[super init])) {
        
		// ask director for the window size
		CGSize size = [[CCDirector sharedDirector] winSize];
        
		CCSprite *background;
		
		if( UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone ) {
			background = [CCSprite spriteWithFile:@"loading.png"];
			//background.rotation = 90;
		} else {
			background = [CCSprite spriteWithFile:@"loading.png"];
		}
		background.position = ccp(size.width/2, size.height/2);
        
		// add the label as a child to this Layer
		[self addChild: background];
        [self setNextScene:sceneID];
        //[self loadNextScene];
        [NSThread detachNewThreadSelector:@selector(loadNextScene) toTarget:self withObject:nil];
	}
	
	return self;
}

+(id) layerWithNextSceneID:(int)sceneID
{
    return [[[self alloc] initWithNextSceneID:sceneID] autorelease];
}



-(void) setNextScene:(int)sceneID
{
    nextSceneID = sceneID;
}

-(void) loadNextScene
{
    //stop the back music
    if ([[SimpleAudioEngine sharedEngine] isBackgroundMusicPlaying]) {
        [[SimpleAudioEngine sharedEngine] stopBackgroundMusic];
    }
    
    //CCScene* sc = nil;
    //todo:  1, remove all sound; 2, remove all animation; 3, init sound for this scene; 4, init animation for this scene; 5, save the file rec; 6, create the scene; 7, replace scene.
    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
    
    [[ShareGameObjectManager shareGameObjectManager] removeAnimateCache];
    [[ShareGameObjectManager shareGameObjectManager] removeSoundCache];
    int scre = [[ShareGameObjectManager shareGameObjectManager] getScreenResolution];
    [[ShareGameObjectManager shareGameObjectManager] initAllAnimationInScene:nextSceneID screenResolution:scre];
    [[ShareGameObjectManager shareGameObjectManager] saveFileRecordInInit];
    
    [self performSelectorOnMainThread:@selector(replaceScene) withObject:nil waitUntilDone:false];
    [pool release];
}

-(void) replaceScene
{
    [[CCDirector sharedDirector] replaceScene:[GameMainScene nodeWithSceneID:nextSceneID]];
}


@end
