//
//  OptionLayer.m
//  theLastNinja
//
//  Created by lai qing on 13-11-3.
//  Copyright 2013年 Tide Studio Game. All rights reserved.
//

#import "OptionLayer.h"


@implementation OptionLayer

-(id) init
{
    if( (self=[super init]) ) {
        //get music / sound / tutorial info from sharegamemanager
        imusic = [[ShareGameObjectManager shareGameObjectManager] getMusic];
        if (imusic == 0) {
            music_font = [CCLabelBMFont labelWithString:@"Music off" fntFile:@"ninja-menu.fnt"];
            music = [TouchAbleSprite spriteWithFile:@"checkoff.png"];
        }
        else {
            music_font = [CCLabelBMFont labelWithString:@"Music on" fntFile:@"ninja-menu.fnt"];
            music = [TouchAbleSprite spriteWithFile:@"checkon.png"];
        }
        isound = [[ShareGameObjectManager shareGameObjectManager] getSound];
        if (isound == 0) {
            sound_font = [CCLabelBMFont labelWithString:@"Sound off" fntFile:@"ninja-menu.fnt"];
            sound = [TouchAbleSprite spriteWithFile:@"checkoff.png"];
        }
        else {
            sound_font = [CCLabelBMFont labelWithString:@"Sound on" fntFile:@"ninja-menu.fnt"];
            sound = [TouchAbleSprite spriteWithFile:@"checkon.png"];
        }
        itutorial = [[ShareGameObjectManager shareGameObjectManager] getTutorial];
        if (itutorial == 0) {
            tutorial_font = [CCLabelBMFont labelWithString:@"Tutorial off" fntFile:@"ninja-menu.fnt"];
            tutorial = [TouchAbleSprite spriteWithFile:@"checkoff.png"];
        }
        else {
            tutorial_font = [CCLabelBMFont labelWithString:@"Tutorial on" fntFile:@"ninja-menu.fnt"];
            tutorial = [TouchAbleSprite spriteWithFile:@"checkon.png"];
        }
        
        music.position = ccp(60,380);
        [self addChild:music];
        
        sound.position = ccp(60,315);
        [self addChild:sound];
        
        tutorial.position = ccp(60,250);
        [self addChild:tutorial];
        
        
        //CCMenu
        CCMenuItemLabel* m1 = [CCMenuItemLabel itemWithLabel:music_font target:self selector:@selector(setMusic)];
        CCMenuItemLabel* s1 = [CCMenuItemLabel itemWithLabel:sound_font target:nil selector:nil];
        CCMenuItemLabel* t1 = [CCMenuItemLabel itemWithLabel:tutorial_font target:nil selector:nil];
        
        CCMenu *menu = [CCMenu menuWithItems:m1,s1,t1, nil];
        //[menu alignItemsVertically];
        [menu alignItemsVerticallyWithPadding:26];
        
        //[menu alignItemsHorizontallyWithPadding:20];
        CGSize size = [[CCDirector sharedDirector] winSize];
        
        [menu setPosition:ccp( size.width/2-10, 316)];
        [self addChild:menu];
        
        back = [TouchAbleSprite spriteWithFile:@"goback.png"];
        [back initLayer:self withSelector:@selector(gobackScene) defaultImageFile:@"goback.png" pressImageFile:@"goback.png" imageInCache:NO];
        back.position = ccp(20,30);
        [self addChild:back z:1];
    }
    return self;
}

-(void) dealloc
{
    [super dealloc];
}

-(void) setMusic
{
    if (imusic == 0) {
        imusic = 1;
    }
    else {
        imusic = 0;
    }
    [[ShareGameObjectManager shareGameObjectManager] setMusic:imusic];
    //change font and image
    imusic == 1? [music_font setString:@"Music on"] : [music_font setString:@"Music off"];
    if (imusic == 1) {
        CCTexture2D *tex = [[CCTextureCache sharedTextureCache] addImage:@"checkon.png"];
        [music setTexture:tex];
    }
    else {
        CCTexture2D *tex = [[CCTextureCache sharedTextureCache] addImage:@"checkoff.png"];
        [music setTexture:tex];
    }
}


-(void) gobackScene
{
    [[ShareGameObjectManager shareGameObjectManager] goBackScene];
}

@end
