//
//  SKHurtObject.h
//  DoodleDrop
//
//  Created by lai qing on 13-7-26.
//
//

#import <Foundation/Foundation.h>
#import "cocos2d.h"
#import "JumpProtocol.h"
#import "TextRunUpEffect.h"

@interface SKHurtObject : NSObject<HurtObject> {
    //
    int hurtValue_;
    int hurtToEnemyOrPlayer_ ; // always 1
    CCLayer<AccelerationPos> *owner_;
    CGRect affectRect_;    // hurt area
    int durableHurtType_;  // 0 none , 1 fire , 2 ice , 3 lightning
    int durableHurtTime_;  // schedule for the recv player or enemybot to lose hp
    int durableHurtValue_; // each time lose hp value
    
}

+(id) hurtWithRect:(CGRect)boundRect withOwnerLayer:(CCLayer<AccelerationPos>*)owner hurtValue:(int)hurtValue hurtToEnemyOrPlayer:(int)eorp durableHurtType:(int)dtype durableHurtValue:(int)dvalue durableHurtTime:(int)dtime;
-(id) initWithRect:(CGRect)boundRect withOwnerLayer:(CCLayer<AccelerationPos>*)owner hurtValue:(int)hurtValue hurtToEnemyOrPlayer:(int)eorp durableHurtType:(int)dtype durableHurtValue:(int)dvalue durableHurtTime:(int)dtime;
-(int) hurtValue;
-(int) hurtToEnemyOrPlayer;
-(CGRect) hurtArea;
-(CCLayer<AccelerationPos>*) ownerLayer;
-(int) durableHurtType ;  //fire ice lightning ...
-(int) durableHurtTime ; // hurt persist time ... a value decrease every sec , when == 0 , stop lose hp
-(int) durableHurtValue ;  //each second lose hp
-(void) checkCollision ; // if to player , check collision with player , player recv hurt , if to enemy , for each in enemyBots[] , if collise ,  bot.recv hurtobj, finally dealloc self.

@end
