//
//  SKHurtObject.m
//  DoodleDrop
//
//  Created by lai qing on 13-7-26.
//
//

#import "SKHurtObject.h"

@implementation SKHurtObject

+(id) hurtWithRect:(CGRect)boundRect withOwnerLayer:(CCLayer<AccelerationPos>*)owner hurtValue:(int)hurtValue hurtToEnemyOrPlayer:(int)eorp durableHurtType:(int)dtype durableHurtValue:(int)dvalue durableHurtTime:(int)dtime
{
    self = [[self alloc] initWithRect:(CGRect)boundRect withOwnerLayer:(CCLayer<AccelerationPos>*)owner hurtValue:(int)hurtValue hurtToEnemyOrPlayer:(int)eorp durableHurtType:(int)dtype durableHurtValue:(int)dvalue durableHurtTime:(int)dtime];
    return self;
}

-(id) initWithRect:(CGRect)boundRect withOwnerLayer:(CCLayer<AccelerationPos>*)owner hurtValue:(int)hurtValue hurtToEnemyOrPlayer:(int)eorp durableHurtType:(int)dtype durableHurtValue:(int)dvalue durableHurtTime:(int)dtime
{
    if ((self = [super init])) {
        affectRect_ = boundRect;
        owner_ = owner;
        hurtValue_ = hurtValue;
        hurtToEnemyOrPlayer_ = eorp;
        durableHurtValue_ = dvalue;
        durableHurtType_ = dtype;
        durableHurtTime_ = dtime;
    }
    return self;
}

-(int) hurtValue
{
    return hurtValue_;
}

-(int) hurtToEnemyOrPlayer
{
    return hurtToEnemyOrPlayer_ ;
}

-(CGRect) hurtArea
{
    return affectRect_;
}

-(CCLayer<AccelerationPos>*) ownerLayer
{
    return owner_;
}

//fire ice lightning ...
-(int) durableHurtType   
{
    return durableHurtType_;
}

// hurt persist time ... a value decrease every sec , when == 0 , stop lose hp
-(int) durableHurtTime
{
    return durableHurtTime_;
}

//each second lose hp
-(int) durableHurtValue
{
    return durableHurtValue_;
}

// if to player , check collision with player , player recv hurt , if to enemy , for each in enemyBots[] , if collise ,  bot.recv hurtobj, finally dealloc self.
-(void) checkCollision
{
    if (hurtToEnemyOrPlayer_ == HURT_TO_ENEMY) {
        CGPoint playerPos = [owner_ returnPlayerPos];
        CCArray *enemys = [owner_ getEnemyList];
        if (enemys != nil) {
            CCSprite<EnemyBot> *_bot;
            CCARRAY_FOREACH(enemys, _bot)
            {
                int botState = [_bot getState];
                if (botState == ENEMY_DEAD_STATE) {
                    continue;
                }
                CGRect botRect = [_bot getBotBoundRect];
                if (CGRectIntersectsRect(botRect, affectRect_)) {
                    [_bot changeState:ENEMY_HURT_STATE intoFighting:1 withPlayerPosition:playerPos withHurtObject:self];
                    
                }
            }
        }
    }
    else if (hurtToEnemyOrPlayer_ == HURT_TO_PLAYER) {
        CGRect playerRect = [owner_ returnPlayerBoundBox];
        CGPoint playerPos = [owner_ returnPlayerPos];
        CGPoint txtpos = ccpAdd(playerPos, ccp(0,playerRect.size.height/2 - 10));
        if (CGRectIntersectsRect(playerRect, affectRect_)) {
            [owner_ playerRecvHurt:self];
            TextRunUpEffect *te = [[TextRunUpEffect alloc] init];
            NSString *hurtstr = [NSString stringWithFormat:@"-%d",hurtValue_ ];
            [te initSprite:txtpos withLayer:owner_ withColor:ccc3(255,255,0) withFontSize:20 withText:hurtstr];
        }
    }
    [self release];
}

-(void) dealloc
{
    [super dealloc];
}

@end
