//
//  SKSprite.h
//  DoodleDrop
//
//  Created by lai qing on 13-7-12.
//  Copyright 2013年 __MyCompanyName__. All rights reserved.
//


#import "cocos2d.h"
#import "JumpProtocol.h"
#import "SKHurtObject.h"



@interface SKSprite : CCSprite<EnemyBot> {
    CCSpriteBatchNode *sb_;
    CCLayer<AccelerationPos> *owner_;
    CCSprite *currentLevel_;
    
    CGPoint playerPosition_;
    
    int contentWidth;
    int contentHeight;
    
    int hp;
    int hpMax;
    int state_;
    int damage_;
    int speed_;
    int level_;
    int genItem_ ;
    int genExp_ ;
    
    int fighting_;
    
    int durableHurtOn_;  // 1 fire 2 ice 3 lightning 4 poison
    
    
    int fireDamage_;
    int iceDamage_;
    int poisonDamage_;
    
    int firedDuration_;
    int iceDuration_;
    int poisonDuration_;
    
    
    
    //damage , speed , defend , level , generated item , gen exp,
    CCParticleSystem *bloodSystem;
    
    
}


-(void) initBatchSpriteNode:(CCSpriteBatchNode*)sb withOwnerLayer:(CCLayer<AccelerationPos>*)owner withLevel:(CCSprite*)level;
-(void) initAllStateWithPlayerDefend:(int)playerDefend playerLevel:(int)playerLevel;
-(id) generateAnimation:(int)animationID;  //return CCAnimation object
-(void) stopActionByID:(int)actionID;
-(id) generateWalkAction;

-(CGRect) getBotBoundRect;
-(void) changeState:(int)state intoFighting:(int)fighting withPlayerPosition:(CGPoint)playerPosition  withHurtObject:(NSObject<HurtObject>*)hobj;
-(void) changeState:(int)state;
-(void) resetStateToIdle;
-(void) changeFighting:(int)fighting;
-(void) resetHeight:(float)playerJumpMove;

-(void) noticePlayerLanding:(CCSprite*)landingLevel withPlayerPosition:(CGPoint)playerPostion;
-(void) noticePlayerJumping;

-(void) generateHurtObject;
-(void) receiveHurt:(NSObject<HurtObject>*)HurtObject;
-(BOOL) judgeAttackAvailable;

-(void) callbackFinish;
-(void) callbackCheckFalling;
-(void) update:(ccTime)delta; //check the state for animation , check collision, check player in sight , check current level range to patrol

-(void) scheduleUpdateInFire:(ccTime)delta;
-(void) scheduleUpdateInIce:(ccTime)delta;
-(void) scheduleUpdateInPoison:(ccTime)delta;
-(void) unScheduleAllHurt;




@end
