//
//  SKSprite.m
//  DoodleDrop
//
//  Created by lai qing on 13-7-12.
//  Copyright 2013年 __MyCompanyName__. All rights reserved.
//

#import "SKSprite.h"


@implementation SKSprite

-(void) initBatchSpriteNode:(CCSpriteBatchNode*)sb withOwnerLayer:(CCLayer<AccelerationPos>*)owner withLevel:(CCSprite *)level
{
    sb_ = sb;
    owner_ = owner;
    currentLevel_ = level;
}


-(void) initAllStateWithPlayerDefend:(int)playerDefend playerLevel:(int)playerLevel
{
    level_ = playerLevel + 2 ;
    hp = 100 + (level_-1)*2 ;
    hpMax = hp ;
    state_ = ENEMY_IDLE_STATE ;  // 0 init or idle , 1 walk , 2 attack , 3 hurt , 4 dead
    damage_ = playerDefend + 20 + arc4random()%5;
    speed_ = 50;
    genItem_ = 0 ;
    genExp_ = 8 + arc4random()%4;  // < 4 , == 6 , > 8 , >> 16
    fighting_ = 0;
    
    durableHurtOn_ = DURABLE_HURT_TYPE_NONE;
    fireDamage_ = 0;
    firedDuration_ = 0;
    iceDamage_ = 0;
    iceDuration_ = 0;
    poisonDamage_ = 0;
    poisonDuration_ = 0;
    
    contentHeight = self.contentSize.height ;
    contentWidth = self.contentSize.width ;
    
    //schedule update
    [self scheduleUpdate];
    //[self schedule:@selector(update:) interval:0.5f];
}

-(void) dealloc
{
    [self unScheduleAllHurt];
    [self unscheduleUpdate];
    //[self unschedule:@selector(update:)];
    [super dealloc];
    
}

-(id) generateAnimation:(int)animationID
{
    //id , 100 , walk , 102 , attack , 103 , hurt , 104 , dead
    if (animationID==ENEMY_IDLE_ANIMATION_ID) {
        [self stopAllActions];
        CCAnimation *aniact = [[CCAnimationCache sharedAnimationCache] animationByName:@"skWalk"];
        CCAnimate *a1 = [CCAnimate actionWithAnimation:aniact];
        //CCAnimate *a1 = [CCAnimate actionWithDuration:2.0f animation:aniact restoreOriginalFrame:YES];
        return a1;
    }
    else if (animationID==ENEMY_WALK_ANIMATION_ID) {
        [self stopAllActions];
        CCAnimation *aniact = [[CCAnimationCache sharedAnimationCache] animationByName:@"skWalk"];
        CCAnimate *a1 = [CCAnimate actionWithAnimation:aniact];
        //CCAnimate *a1 = [CCAnimate actionWithDuration:2.0f animation:aniact restoreOriginalFrame:YES];
        //repeated all
        CCRepeatForeverAnimation *rep = [CCRepeatForeverAnimation actionWithAction:a1];
        rep.tag = ENEMY_WALK_ACTION_ID;
        return rep;
    }
    else if (animationID==ENEMY_ATTACK_ANIMATION_ID) {
        [self stopAllActions];
        CCAnimation *aniact = [[CCAnimationCache sharedAnimationCache] animationByName:@"skAttack"];
        CCAnimate *a1 = [CCAnimate actionWithAnimation:aniact];
        //CCAnimate *a1 = [CCAnimate actionWithDuration:0.4f animation:aniact restoreOriginalFrame:YES];
        return a1;
    }
    else if (animationID==ENEMY_HURT_ANIMATION_ID) {
        [self stopAllActions];
        CCAnimation *aniact = [[CCAnimationCache sharedAnimationCache] animationByName:@"skHurt"];
        CCAnimate *a1 = [CCAnimate actionWithAnimation:aniact];
        //CCAnimate *a1 = [CCAnimate actionWithDuration:0.05f animation:aniact restoreOriginalFrame:YES];
        return a1;
    }
    else if (animationID==ENEMY_DEAD_ANIMATION_ID) {
        [self stopAllActions];
        CCAnimation *aniact = [[CCAnimationCache sharedAnimationCache] animationByName:@"skDead"];
        CCAnimate *a1 = [CCAnimate actionWithAnimation:aniact];
        //CCAnimate *a1 = [CCAnimate actionWithDuration:0.25f animation:aniact restoreOriginalFrame:NO];
        return a1;
    }
    else {
        return nil;
    }
    
    
}

-(void) stopActionByID:(int)actionID {
    if (actionID == ENEMY_IDLE_ACTION_ID) {
        id act = [self getActionByTag:ENEMY_IDLE_ACTION_ID];
        if (act != nil) {
            [self stopActionByTag:ENEMY_IDLE_ACTION_ID];
        }
    }
    else if (actionID==ENEMY_WALK_ACTION_ID) {
        id act = [self getActionByTag:ENEMY_WALK_ACTION_ID];
        if (act != nil) {
            [self stopActionByTag:ENEMY_WALK_ACTION_ID];
        }
    }
    else if (actionID==ENEMY_WALK_MOVE_ACTION_ID) {
        id act = [self getActionByTag:ENEMY_WALK_MOVE_ACTION_ID];
        if (act != nil) {
            [self stopActionByTag:ENEMY_WALK_MOVE_ACTION_ID];
        }
    }
    else if (actionID==ENEMY_ATTACK_ACTION_ID) {
        id act = [self getActionByTag:ENEMY_ATTACK_ACTION_ID];
        if (act != nil) {
            [self stopActionByTag:ENEMY_ATTACK_ACTION_ID];
        }
    }
    else if (actionID==ENEMY_HURT_ACTION_ID) {
        id act = [self getActionByTag:ENEMY_HURT_ACTION_ID];
        if (act != nil) {
            [self stopActionByTag:ENEMY_HURT_ACTION_ID];
        }
    }
    else if (actionID==ENEMY_DEAD_ACTION_ID) {
        id act = [self getActionByTag:ENEMY_DEAD_ACTION_ID];
        if (act != nil) {
            [self stopActionByTag:ENEMY_DEAD_ACTION_ID];
        }
    }
    

}

//这个方法用于检查bot站的位置是在左边、中间、还是右边。脸是向左还是向右，如果站在最左端脸还是向左，那么就把他翻转一下。
-(int) checkBotPosition
{
    if (currentLevel_ != nil) {
        CGFloat right = currentLevel_.position.x + currentLevel_.contentSize.width/2;
        CGFloat left = currentLevel_.position.x - currentLevel_.contentSize.width/2;
        if ((self.position.x < right)&&(self.position.x > left)) {
            if (self.flipX==NO) {
                //CCLOG(@"bot face to right , left < bot < right ");
                return 1;
            }
            else {
                //CCLOG(@"bot face to left, left < bot < right ");
                return 2;
            }
        }
        else if (self.position.x <= left) {
            if (self.flipX==YES) {
                //CCLOG(@"turn back , on the left.");
                self.flipX = NO;
            }
            return 1;
        }
        //on the right
        else  {
            if (self.flipX==NO) {
                //CCLOG(@"turn back , on the right");
                self.flipX = YES;
            }
            return 2;
        }
    }
    else return 1;
}

-(id) generateWalkAction
{
    
    //move to level edge
    CCResetableMoveTo *m = nil;
    if (fighting_ == 0) {
        if ([self checkBotPosition]==1) {
            ccTime dur = (currentLevel_.position.x + currentLevel_.contentSize.width/2 - self.position.x)/speed_ ;
            m = [CCResetableMoveTo actionWithDuration:dur position:ccp(currentLevel_.position.x + currentLevel_.contentSize.width/2,self.position.y) withOwner:self objFinalState:ENEMY_IDLE_STATE];
        }
        else {
            ccTime dur = (self.position.x - currentLevel_.position.x + currentLevel_.contentSize.width/2 )/speed_ ;
            m = [CCResetableMoveTo actionWithDuration:dur position:ccp(currentLevel_.position.x - currentLevel_.contentSize.width/2,self.position.y) withOwner:self objFinalState:ENEMY_IDLE_STATE];
        }
    }
    else if ((playerPosition_.x != 0)&&(playerPosition_.y != 0)) {
        
        //walk to player , first check position , after check , set the bot to the right face
        [self checkBotPosition];
        if (playerPosition_.x > self.position.x) {
            if (self.flipX == YES) {
                self.flipX = NO;
            }
            //
            ccTime dur = (playerPosition_.x - self.position.x)/speed_ ;
            m = [CCResetableMoveTo actionWithDuration:dur position:playerPosition_ withOwner:self objFinalState:ENEMY_IDLE_STATE];
        }
        else {
            if (self.flipX==NO) {
                self.flipX = YES;
            }
            ccTime dur = (self.position.x - playerPosition_.x)/speed_ ;
            m = [CCResetableMoveTo actionWithDuration:dur position:playerPosition_ withOwner:self objFinalState:ENEMY_IDLE_STATE];
        }
        
    }
    else {
        if ([self checkBotPosition]==1) {
            ccTime dur = (currentLevel_.position.x + currentLevel_.contentSize.width/2 - self.position.x)/speed_ ;
            m = [CCResetableMoveTo actionWithDuration:dur position:ccp(currentLevel_.position.x + currentLevel_.contentSize.width/2,self.position.y) withOwner:self objFinalState:ENEMY_IDLE_STATE];
        }
        else {
            ccTime dur = (self.position.x - currentLevel_.position.x + currentLevel_.contentSize.width/2 )/speed_ ;
            m = [CCResetableMoveTo actionWithDuration:dur position:ccp(currentLevel_.position.x - currentLevel_.contentSize.width/2,self.position.y) withOwner:self objFinalState:ENEMY_IDLE_STATE];
        }
    }
    return m;

}



-(void) generateHurtObject
{
    //gen hurt object
    //hurt check for collision with player
    //hurt object release
    CGRect hurtArea ;
    if (self.flipX==NO) {
        //面向右
        hurtArea = CGRectMake(self.position.x+self.contentSize.width/2, self.position.y-self.contentSize.height/2, 40, self.contentSize.height);
    }
    else {
        hurtArea = CGRectMake(self.position.x-self.contentSize.width/2-40, self.position.y-self.contentSize.height/2, 40, self.contentSize.height);
    }
    SKHurtObject *hobj = [SKHurtObject hurtWithRect:hurtArea withOwnerLayer:owner_ hurtValue:damage_ hurtToEnemyOrPlayer:HURT_TO_PLAYER durableHurtType:DURABLE_HURT_TYPE_NONE durableHurtValue:0 durableHurtTime:0];
    [hobj checkCollision]; //no need to release hobj , it release in the checkCollision inside.
}

-(CGRect) getBotBoundRect
{
    
    
    CGRect b = [self boundingBox];
    //float xoffset = b.size.width * 0.15f ;
    float yoffset = b.size.height * 0.15f ;
    CGRect rs = CGRectMake(b.origin.x, b.origin.y + yoffset, b.size.width, b.size.height - 2*yoffset);
    return rs;

    //return [self boundingBox];
}

//当player跳起时，从fighting_ = 1 变回 0 ， 由CCLayer调用
-(void) changeFighting:(int)fighting
{
    fighting_ = fighting;
}

-(void) resetStateToIdle
{
    if (hp>0)
        state_ = ENEMY_IDLE_STATE;
    
}

-(void) checkIfDead
{
    //检查hp是否小于0，是则转入死亡
    CCLOG(@"call check if dead...");
    if (hp <= 0) {
        if (state_ == ENEMY_DEAD_STATE) {
            //already set state to dead , the animation may in progress , do nothing
            
        }
        else {
            state_ = ENEMY_DEAD_STATE;
            [self unScheduleAllHurt];
            //player can move now
            [owner_ unsetPlayerColliseInLeft];
            [owner_ unsetPlayerColliseInRight];
            
            //if already dead , return , else play ani , callback finish
            [self stopAllActions];
            fighting_ = 0;
            
            CCAnimate *deadam = [self generateAnimation:ENEMY_DEAD_ANIMATION_ID];
            CCBlink *bl = [CCBlink actionWithDuration:1.0f blinks:4];
            CCDelayTime *dt = [CCDelayTime actionWithDuration:1.0f];
            CCNonReleaseCallFunc *fin = [CCNonReleaseCallFunc actionWithTarget:self selector:@selector(callbackFinish)];
            CCSequence *dseq = [CCSequence actions:deadam,bl,dt,fin, nil];
            dseq.tag = ENEMY_DEAD_ACTION_ID;
            [self runAction:dseq];
            
        }
    }
    else
        [self resetStateToIdle];
}

//被update botAI调用
-(void) changeState:(int)state intoFighting:(int)fighting  withPlayerPosition:(CGPoint)playerPosition withHurtObject:(NSObject<HurtObject>*)hobj
{
    switch (state) {
        case ENEMY_IDLE_STATE:
            if (state_ == ENEMY_RESET_HEIGHT_STATE) return;
            [self stopAllActions];
            state_ = ENEMY_IDLE_STATE;
            fighting_ = fighting;
            if ((playerPosition.x != 0)&&(playerPosition.y != 0)) {
                playerPosition_ = ccp(playerPosition.x,playerPosition.y);
            }
            CCAnimate *act = [self generateAnimation:ENEMY_IDLE_ANIMATION_ID];
            //CCNonReleaseCallFunc *AI = [CCNonReleaseCallFunc actionWithTarget:self selector:@selector(botAI)];
            //CCSequence *seq = [CCSequence actions:act,AI, nil];
            act.tag = ENEMY_IDLE_ACTION_ID;
            [self runAction:act];
            break;
        
        case ENEMY_WALK_STATE:
            if (state_ == ENEMY_RESET_HEIGHT_STATE) return;
            [self stopAllActions];
            CCRepeatForeverAnimation *rep = [self generateAnimation:ENEMY_WALK_ANIMATION_ID];
            [self runAction:rep];
            fighting_ = fighting;
            state_ = ENEMY_WALK_STATE;
            if ((playerPosition.x != 0)&&(playerPosition.y!= 0))
                playerPosition_ = ccp(playerPosition.x,self.position.y);
            CCResetableMoveTo *mt = [self generateWalkAction];
            //CCResetableSpawn *spawn = [CCResetableSpawn actions:rep,mt, nil];
            
            CCNonReleaseCallFunc *reset = [CCNonReleaseCallFunc actionWithTarget:self selector:@selector(resetStateToIdle)];
            
            CCResetableSequence *mseq = [CCResetableSequence actions:mt, reset, nil];
            mseq.tag = ENEMY_WALK_MOVE_ACTION_ID;
            [self runAction:mseq];
            
            //spawn.tag = ENEMY_WALK_MOVE_ACTION_ID;
            //[self runAction:spawn];
            
            break;
            
        case ENEMY_ATTACK_STATE:
            if ((state_ == ENEMY_HURT_STATE)||(state_ == ENEMY_DEAD_STATE)||(state_ == ENEMY_RESET_HEIGHT_STATE)) {
                return ;
            }
            [self stopAllActions];
            fighting_ = fighting;
            state_ = ENEMY_ATTACK_STATE;
            CCAnimate *am = [self generateAnimation:ENEMY_ATTACK_ANIMATION_ID];
            CCNonReleaseCallFunc *genHurt = [CCNonReleaseCallFunc actionWithTarget:self selector:@selector(generateHurtObject)];
            CCNonReleaseCallFunc *reset1 = [CCNonReleaseCallFunc actionWithTarget:self selector:@selector(resetStateToIdle)];
            
            CCSequence *aseq = [CCSequence actions:am, genHurt, reset1, nil];
            aseq.tag = ENEMY_ATTACK_ACTION_ID;
            [self runAction:aseq];
            break;
            
        case ENEMY_HURT_STATE:
            //hurt ani , recv hurt obj, hp - , if hp > 0 , fight back , else dead
            if ((state_ == ENEMY_ATTACK_STATE) || (state_ == ENEMY_WALK_STATE) || (state_ == ENEMY_IDLE_STATE)) {
                [self stopAllActions];
            }
            else if ((state_ == ENEMY_DEAD_STATE)||(state_ == ENEMY_RESET_HEIGHT_STATE)) {
                return;
            }
            fighting_ = fighting;
            state_ = ENEMY_HURT_STATE;
            CCAnimate *hurtam = [self generateAnimation:ENEMY_HURT_ANIMATION_ID];
            CCNonReleaseCallFuncO *recvHurt = [CCNonReleaseCallFuncO actionWithTarget:self selector:@selector(receiveHurt:) object:hobj];
            CCSpawn *spawn2 = [CCSpawn actions:hurtam, recvHurt, nil];
            CCNonReleaseCallFunc *reset2 = [CCNonReleaseCallFunc actionWithTarget:self selector:@selector(resetStateToIdle)];
            
            CCSequence *hseq = [CCSequence actions:spawn2,reset2, nil];
            hseq.tag = ENEMY_HURT_ACTION_ID;
            [self runAction:hseq];
            
            break;
            
        case ENEMY_DEAD_STATE:
            //CCLOG(@"change into dead ... hp: %d , posy : %f , state: %d , %@", hp, self.position.y , state_,self);
            //if already dead , return , else play ani , callback finish
            if (state_ == ENEMY_DEAD_STATE) return;
            state_ = ENEMY_DEAD_STATE;
            [self stopAllActions];
            
            //player can move now
            [owner_ unsetPlayerColliseInLeft];
            [owner_ unsetPlayerColliseInRight];
            
            
            //fighting_ = fighting;
            
            CCAnimate *deadam = [self generateAnimation:ENEMY_DEAD_ANIMATION_ID];
            CCBlink *bl = [CCBlink actionWithDuration:1.0f blinks:4];
            CCDelayTime *dt = [CCDelayTime actionWithDuration:1.0f];
            CCNonReleaseCallFunc *fin = [CCNonReleaseCallFunc actionWithTarget:self selector:@selector(callbackFinish)];
            CCSequence *dseq = [CCSequence actions:deadam,bl,dt,fin, nil];
            dseq.tag = ENEMY_DEAD_ACTION_ID;
            [self runAction:dseq];
            break;
            
        default:
            break;
    }
    
    
}

//这个方法仅仅是修改状态，并不产生动画
-(void) changeToStateWithoutPlayingAction:(int)state {
    state_ = state;
}

//call by CCResetableMoveTo action
-(void) changeState:(int)state
{
    //[self changeState:state intoFighting:fighting_ withPlayerPosition:playerPosition_];
    state_ = state;
}

-(void) resetHeight:(CGFloat)playerJumpMove
{
    if (state_ != ENEMY_DEAD_STATE)
    {
        [self stopAllActions];
        state_ = ENEMY_RESET_HEIGHT_STATE;
        CGPoint pos= ccp(self.position.x , self.position.y - playerJumpMove);
        self.position = pos;
        state_ = ENEMY_IDLE_STATE;
    }
    else {
        CGPoint pos= ccp(self.position.x , self.position.y - playerJumpMove);
        self.position = pos;
    }
    /*
    //if in move action , reset the start position , try to get the CCResetableMoveTo action ,
    //if in other action , just reset the position
    if (state_==ENEMY_WALK_STATE) {
        CCAction *sp = [self getActionByTag:ENEMY_WALK_MOVE_ACTION_ID];
        if ([sp isKindOfClass:[CCResetableSpawn class]]) {
            CCResetableSpawn *rsp = (CCResetableSpawn*)sp;
            [rsp resetHeight:playerJumpMove];
        }
        else if ([sp isKindOfClass:[CCResetableSequence class]]) {
            CCResetableSequence *rseq = (CCResetableSequence*)sp;
            [rseq resetHeight:playerJumpMove];
        }
        
    }
    else {
        CGPoint pos = ccp(self.position.x, self.position.y - playerJumpMove);
        [self setPosition:pos];
    }
    */
}



-(void) receiveHurt:(NSObject<HurtObject>*)HurtObject
{
    if (HurtObject != nil) {
        int hv = [HurtObject hurtValue];
        hp -= hv;
        
        TextRunUpEffect *te = [[TextRunUpEffect alloc] init];
        NSString *hurtstr = [NSString stringWithFormat:@"-%d",hv ];
        [te initSprite:self.position withLayer:owner_ withColor:ccc3(255,0,0) withFontSize:20 withText:hurtstr];
        
        //add blood splash
        bloodSystem = [CCParticleSystemQuad particleWithFile:@"bloodSplash3.plist"];
        //bloodSystem.scale = 0.3f;
        bloodSystem.position = ccp(self.position.x,self.position.y);
        
        bloodSystem.duration = 0.05f;
        if (self.flipX == NO) {
            bloodSystem.angle = 135;
            bloodSystem.angleVar = 20;
            
        }
        else {
            bloodSystem.angle = 45;
            bloodSystem.angleVar = 20;
        }
        bloodSystem.speed = 100;
        bloodSystem.autoRemoveOnFinish =YES ;
        [owner_ addChild:bloodSystem];
        
        int dtype = [HurtObject durableHurtType];
        if (dtype == DURABLE_HURT_TYPE_FIRE) {
            //unschedule pre durable hurt
            [self unScheduleAllHurt];
            durableHurtOn_ = dtype;
            fireDamage_ = [HurtObject durableHurtValue];
            firedDuration_ = [HurtObject durableHurtTime];
            [self schedule:@selector(scheduleUpdateInFire:) interval:1];
        }
        else if (dtype == DURABLE_HURT_TYPE_ICE) {
            [self unScheduleAllHurt];
            durableHurtOn_ = dtype;
            iceDamage_ = [HurtObject durableHurtValue];
            iceDuration_ = [HurtObject durableHurtTime];
            [self schedule:@selector(scheduleUpdateInIce:) interval:1];
            
        }
        else if (dtype == DURABLE_HURT_TYPE_POISON) {
            [self unScheduleAllHurt];
            durableHurtOn_ = dtype;
            poisonDamage_ = [HurtObject durableHurtValue];
            poisonDuration_ = [HurtObject durableHurtTime];
            [self schedule:@selector(scheduleUpdateInPoison:) interval:1];
        }
        
    }
}

-(void) unScheduleAllHurt
{
    if (durableHurtOn_ == DURABLE_HURT_TYPE_FIRE) {
        [self unschedule:@selector(scheduleUpdateInFire:)];
    }
    else if (durableHurtOn_ == DURABLE_HURT_TYPE_ICE) {
        [self unschedule:@selector(scheduleUpdateInIce:)];
    }
    else if (durableHurtOn_ == DURABLE_HURT_TYPE_POISON) {
        [self unschedule:@selector(scheduleUpdateInPoison:)];
    }
    durableHurtOn_ = DURABLE_HURT_TYPE_NONE;
}

-(void) scheduleUpdateInFire:(ccTime)delta
{
    if (firedDuration_ <= 0) {
        [self unschedule:_cmd];
        durableHurtOn_ = DURABLE_HURT_TYPE_NONE;
        fireDamage_ = 0;
        firedDuration_ = 0;
    }
    else {
        hp -= fireDamage_;
        //run text up effect in red
        firedDuration_ -= 1 ;
        //[self botAI]; //check if dead
        //[self checkIfDead];
    }
}
-(void) scheduleUpdateInIce:(ccTime)delta
{
    if (iceDuration_ <= 0) {
        [self unschedule:_cmd];
        durableHurtOn_ = DURABLE_HURT_TYPE_NONE;
        iceDamage_ = 0;
        iceDuration_ = 0;
    }
    else {
        hp -= iceDamage_;
        //run text up effect in red
        iceDuration_ -= 1 ;
        //[self botAI]; //check if dead
        //[self checkIfDead];
    }
}
-(void) scheduleUpdateInPoison:(ccTime)delta
{
    if (firedDuration_ <= 0) {
        [self unschedule:_cmd];
        durableHurtOn_ = DURABLE_HURT_TYPE_NONE;
        poisonDamage_ = 0;
        poisonDuration_ = 0;
    }
    else {
        hp -= poisonDamage_;
        //run text up effect in red
        poisonDuration_ -= 1 ;
        //[self botAI]; //check if dead
        //[self checkIfDead];
    }
}

-(BOOL) judgeAttackAvailable
{
    //get player position , find if can attack , if nearby the player return YES , if self is throwable enemy return YES
    //如果正在attack或者hurt，则return NO
    if (state_== ENEMY_DEAD_STATE) {
        return NO;
    }
    id act = [self getActionByTag:ENEMY_HURT_ACTION_ID];
    if (act != nil) {
        return NO;
    }
    act = [self getActionByTag:ENEMY_ATTACK_ACTION_ID];
    if (act != nil) {
        return NO;
    }
    return YES;
}

-(void) noticePlayerLanding:(CCSprite*)landingLevel withPlayerPosition:(CGPoint)playerPostion
{
    if (hp <= 0) {
        //do nothing
        return;
    }
    if (currentLevel_ != nil) {
        if (currentLevel_ == landingLevel) {
            //CCLOG(@"finding player, position:(%f,%f)",self.position.x,self.position.y);
            //same level , if face to player
            CGPoint newpos = ccp(playerPostion.x,self.position.y);
            if ( self.flipX == YES ) {
                //face to left
                if (playerPostion.x < self.position.x) {
                    //change to fighting mode
                    fighting_ = 1 ;
                    // ...
                    //CCLOG(@"notice playerLanding, state: %d , positiony: %f , %@",state_,self.position.y,self);
                    [self changeState:ENEMY_WALK_STATE intoFighting:1 withPlayerPosition:newpos withHurtObject:nil];
                }
                else {
                    int rate = arc4random()%10;
                    //CCLOG(@"turn back ratio: %d",rate);
                    if (rate<=1) {
                        fighting_ = 1;
                        // todo : turn back , and walk toward player
                        self.flipX = NO;
                        //CCLOG(@"notice playerLanding, state: %d , positiony: %f , %@",state_,self.position.y,self);
                        [self changeState:ENEMY_WALK_STATE intoFighting:1 withPlayerPosition:newpos withHurtObject:nil];
                    }
                    else {
                        //do nothing
                        //CCLOG(@"do not turn back.");
                    }
                }
            }
            // flipX == NO
            else {
                if (playerPostion.x > self.position.x) {
                    fighting_ = 1;
                    // ...
                    //CCLOG(@"notice playerLanding, state: %d , positiony: %f , %@",state_,self.position.y,self);
                    [self changeState:ENEMY_WALK_STATE intoFighting:1 withPlayerPosition:newpos withHurtObject:nil];
                }
                else {
                    int rate = arc4random()%10;
                    //CCLOG(@"turn back ratio: %d",rate);
                    if (rate <= 1) {
                        fighting_ = 1;
                        //todo : turn back , walk toward player
                        self.flipX = YES;
                        //CCLOG(@"notice playerLanding, state: %d , positiony: %f , %@",state_,self.position.y,self);
                        [self changeState:ENEMY_WALK_STATE intoFighting:1 withPlayerPosition:newpos withHurtObject:nil];
                    }
                    else {
                        //do nothing
                        //CCLOG(@"do not turn back.");
                    }
                }
            }
        }
    }
}

-(void) noticePlayerJumping
{
    fighting_ = 0;
    playerPosition_ = ccp(0,0);
}



-(void) callbackFinish
{
    //
    //停止所有动画，设置为不可见，让owner从数组里释放enemybot
    //[self stopAllActions];
    CCLOG(@"callback finish , hp:%d , state:%d",hp,state_);
    [self setVisible:NO];
    if (currentLevel_ != nil) {
        CCSprite<Level> *l = (CCSprite<Level>*)currentLevel_;
        [l noticeBotRelease];
    }
    [owner_ releaseEnemy:self];
}

-(void) callbackCheckFalling
{
    //no action , because always player was bombed.
}

-(void) update:(ccTime)delta //check the state for animation , check collision, check player in sight , check current level range to patrol
{
    //检查hp是否小于0，是则转入死亡
        
    if (hp <= 0) {
        if (state_ != ENEMY_DEAD_STATE) {
            //state_ = ENEMY_DEAD_STATE ;
            [self changeState:ENEMY_DEAD_STATE intoFighting:0 withPlayerPosition:ccp(0,0) withHurtObject:nil];
        }
    }
    else {
    //check if collise with player or obstacle , if fighting==1 , destory the obstacle
    CGRect playerRect = [owner_ returnPlayerBoundBox];
    CGPoint ppos = [owner_ returnPlayerPos];
    int playerState_ = [owner_ getPlayerState];
    //CCLOG(@"player in state: %d , bot in state:%d , player pos y: %f , bot pos y: %f",playerState_,state_,ppos.y, self.position.y);
    //如果右碰撞
    if (CGRectIntersectsRect(playerRect, [self getBotBoundRect])) {
        CCLOG(@"bot state: %d , bot position: %f,%f , bot hp: %d",state_,self.position.x,self.position.y, hp);
        
        //碰撞发生时，bot状态是攻击或受伤，说明正在播放动画，那么不要操作，最多改变player的不能移动状态
        if ((state_ == ENEMY_ATTACK_STATE)||(state_ == ENEMY_HURT_STATE)) {
            //already in attack or hurt , do nothing
            if (self.position.x > ppos.x) {
                [owner_ setPlayerColliseInRight];
                //[owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_LEFT_STATE];
            }
            else {
                [owner_ setPlayerColliseInLeft];
                //[owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_RIGHT_STATE];
            }
            return;
        }
        
        //碰撞发生时，bot已经死亡了，不操作任何东西
        
        else if (state_ == ENEMY_DEAD_STATE) {
            return;
        }
        
        //碰撞发生时，bot在发呆或者在走路
        
        else if ((state_== ENEMY_IDLE_STATE)||(state_ == ENEMY_WALK_STATE)) {
            //如果player的状态是在走路
            if (playerState_ == 0) {
                // walk , idle
                if ((self.position.x > ppos.x)&&(self.flipX == NO)) {
                    //set player can't move to right
                    [owner_ setPlayerColliseInRight];
                    //player runaction new hurtjumpby , direction , player set state == hurt in jump , and can't move in accelration
                    //[owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_LEFT_STATE];
                }
                else if ((self.position.x < ppos.x)&&(self.flipX == YES)) {
                    //set player can't move to left
                    [owner_ setPlayerColliseInLeft];
                    //[owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_RIGHT_STATE];
                }
                else {
                    if (self.position.x > ppos.x) {
                        [owner_ setPlayerColliseInRight];
                        //[owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_LEFT_STATE];
                    }
                    else {
                        [owner_ setPlayerColliseInLeft];
                        //[owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_RIGHT_STATE];
                    }
                    [self changeState:ENEMY_ATTACK_STATE intoFighting:1 withPlayerPosition:ppos withHurtObject:nil];
                }
            }
            //如果player的状态是在跳跃，把player弹开
            else if ((playerState_== PLAYER_JUMP_STATE)||(playerState_ == PLAYER_FALL_STATE)) {
                if (self.position.x > ppos.x) {
                    //[owner_ playerColliseInRight];
                    [owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_LEFT_STATE];
                }
                else {
                    //[owner_ playerColliseInLeft];
                    [owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_RIGHT_STATE];
                }
            }
            
        }
        //如果bot的状态是在其他状态 只有reset height了
        else {
            // in reset height , player run hurt jump action
            if (self.position.x > ppos.x) {
                //[owner_ playerColliseInRight];
                [owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_LEFT_STATE];
            }
            else {
                //[owner_ playerColliseInLeft];
                [owner_ playerRecvJumpHurt:PLAYER_HURT_ON_AIR_RIGHT_STATE];
            }
        }
    }
    //没有发生碰撞
    else {
        if (state_ == ENEMY_IDLE_STATE) {
            //CCLOG(@"change idle state to walk");
            //CCLOG(@"bot state: %d , positiony: %f , %@",state_, self.position.y,self);
            [self setDisplayFrame:[[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:@"s00.png"]];
            [self changeState:ENEMY_WALK_STATE intoFighting:fighting_ withPlayerPosition:playerPosition_ withHurtObject:nil];
        }
    }
    }
    
}

-(int) getState
{
    return state_;
}


//draw HP / HPMax on the top
-(void)updateTransform
{
    //draw hero hpbar
    if (state_ != ENEMY_DEAD_STATE) {

        //glDisableClientState(GL_COLOR_ARRAY);
        //glDisableClientState(GL_TEXTURE_COORD_ARRAY);
        //glDisable(GL_TEXTURE_2D);
        
        ccGLEnable(GL_LINE_STRIP);
    
        int width = contentWidth ;
        int startx = self.position.x - contentWidth/2 ;
        int posy = self.position.y + contentHeight/2 + 8 ;
        float percentage = (float)hp / (float)hpMax;
        int hpLen = percentage * width ;
    
    
        //glEnable(GL_LINE_SMOOTH);
        glLineWidth(4);
        ccDrawColor4B(0,255,0,255);
        //glColor4ub(0,255,0,255);
        ccDrawLine(ccp(startx,posy),ccp(startx+hpLen,posy));
        ccDrawColor4B(255,0,0,255);
        //glColor4ub(255, 0, 0, 255);
        ccDrawLine(ccp(startx+hpLen,posy), ccp(startx+width,posy));
    
        //glEnableClientState(GL_COLOR_ARRAY);
        //glEnableClientState(GL_TEXTURE_COORD_ARRAY);
        //glEnable(GL_TEXTURE_2D);
    }
    
    [super updateTransform];
    
        
    
}




@end
