//
//  SelectCharacterLayer.m
//  theLastNinja
//
//  Created by lai qing on 13-10-18.
//  Copyright 2013年 Tide Studio Game. All rights reserved.
//

#import "SelectCharacterLayer.h"


@implementation SelectCharacterLayer

-(id) init
{
    if( (self=[super init]) ) {
        
        currentTextProcess = 0;
        maxTextProcess = 0;
        [self loadSpriteAndLabelFromPlist];
        //299 messages并没有在plist里，必须在showMessage里手动生成
        [[[CCDirector sharedDirector] touchDispatcher] addTargetedDelegate:self priority:1 swallowsTouches:YES];
        [self showMessageInDialog:[NSNumber numberWithInt:TEXT_CHARACTER_DESC_0]];
    }
    return self;
}



- (BOOL)ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event {
    return TRUE;
}

- (void)ccTouchEnded:(UITouch *)touch withEvent:(UIEvent *)event {
    //触发对应事件 显示技能说明
    //CGPoint location = [touch locationInView:[touch view]];
	//location = [[CCDirector sharedDirector] convertToGL:location];
    //判断点击的位置是否在技能按钮上
    CGPoint touchLocation = [self convertTouchToNodeSpace:touch];
    for (CCNode* obj in [self children]) {
        if (obj.zOrder >= 0) {
            if (CGRectContainsPoint(obj.boundingBox,touchLocation)) {
                int itag = obj.tag;
                int evtID = [self getResponseID:itag];
                [self dispatchEvent:evtID];
                break;
            }
        }
    }
}



-(int) leftButtonTouch
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    int result = 1;
    int msgID = 240;
    
    CGSize size = [[CCDirector sharedDirector] winSize];
    CGPoint pos = self.position;
    if (pos.x == 0) {
        result = 1;
        msgID = 240;
        return result;
    }
    else if (pos.x == -size.width) {
        result = 1;
        msgID = 240;
    }
    else if (pos.x == -size.width*2) {
        result = 2;
        msgID = 241;
    }
    
    
    //stop the message show first
    [self unscheduleAllSelectors];
    CCNode* messages = [self getChildByTag:299];
    if (messages != nil) {
        [messages stopAllActions];
        [messages removeFromParentAndCleanup:YES];
    }
    
    CGFloat xoffset =  size.width ;
    CCMoveBy* mv = [CCMoveBy actionWithDuration:0.2f position:ccp(xoffset,0)];
    //CCEaseInOut* rmv = [CCEaseInOut actionWithAction:mv];
    [self runAction:mv];
    
    NSNumber* para = [NSNumber numberWithInt:msgID];
    [self performSelector:@selector(showMessageInDialog:) withObject:para afterDelay:0.25f];
    
    return result;
    
}

-(int) rightButtonTouch
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    int result = 1;
    int msgID = 240;
    
    CGSize size = [[CCDirector sharedDirector] winSize];
    CGPoint pos = self.position;
    if (pos.x == 0) {
        result = 2;
        msgID = 241;
    }
    else if (pos.x == -size.width) {
        result = 3;
        msgID = 242;
    }
    else if (pos.x == -size.width*2) {
        result = 3;
        msgID = 242;
        return result;
    }

    
    //stop the message show first
    [self unscheduleAllSelectors];
    CCNode* messages = [self getChildByTag:299];
    if (messages != nil) {
        [messages stopAllActions];
        [messages removeFromParentAndCleanup:YES];
    }
    

    CGFloat xoffset =  -size.width ;
    CCMoveBy* mv = [CCMoveBy actionWithDuration:0.2f position:ccp(xoffset,0)];
    //CCEaseInOut* rmv = [CCEaseInOut actionWithAction:mv];
    [self runAction:mv];
    
    NSNumber* para = [NSNumber numberWithInt:msgID];
    [self performSelector:@selector(showMessageInDialog:) withObject:para afterDelay:0.25f];
    
    return result;
}


-(void) dispatchEvent:(int)evtID
{
    if (evtID == 0) {
        //do nothing
        return;
    }
    else if (evtID == TEXT_CHARACTER_DESC_0) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_CHARACTER_DESC_1) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_CHARACTER_DESC_2) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_0) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_1) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_2) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_3) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_4) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_5) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_6) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_7) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_8) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_9) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_10) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_11) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_12) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_13) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else if (evtID == TEXT_SKILL_DESC_14) {
        //text touch
        [self showMessageInDialog:[NSNumber numberWithInt:evtID]];
    }
    else {
        //do nothing
        return;
    }
    
}

-(int) getResponseID:(int)tagID
{
    int result = 0;
    switch (tagID) {
        case HEAD_0:
            result = TEXT_CHARACTER_DESC_0;
            break;
        case HEAD_1:
            result = TEXT_CHARACTER_DESC_1;
            break;
        case HEAD_2:
            result = TEXT_CHARACTER_DESC_2;
            break;
        case SKILL_0:
            result = TEXT_SKILL_DESC_0;
            break;
        case SKILL_1:
            result = TEXT_SKILL_DESC_1;
            break;
        case SKILL_2:
            result = TEXT_SKILL_DESC_2;
            break;
        case SKILL_3:
            result = TEXT_SKILL_DESC_3;
            break;
        case SKILL_4:
            result = TEXT_SKILL_DESC_4;
            break;
        case SKILL_5:
            result = TEXT_SKILL_DESC_5;
            break;
        case SKILL_6:
            result = TEXT_SKILL_DESC_6;
            break;
        case SKILL_7:
            result = TEXT_SKILL_DESC_7;
            break;
        case SKILL_8:
            result = TEXT_SKILL_DESC_8;
            break;
        case SKILL_9:
            result = TEXT_SKILL_DESC_9;
            break;
        case SKILL_10:
            result = TEXT_SKILL_DESC_10;
            break;
        case SKILL_11:
            result = TEXT_SKILL_DESC_11;
            break;
        case SKILL_12:
            result = TEXT_SKILL_DESC_12;
            break;
        case SKILL_13:
            result = TEXT_SKILL_DESC_13;
            break;
        case SKILL_14:
            result = TEXT_SKILL_DESC_14;
            break;
        default:
            break;
    }
    return result;
    
    

}


-(void) loadSpriteAndLabelFromPlist
{
    //从documents目录下进行查找plist
    NSString *rootpath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSString *plistpath = [rootpath stringByAppendingPathComponent:@"selectCharacterView.plist"];
    //如果未找到，则从bundle里查找
    if (![[NSFileManager defaultManager] fileExistsAtPath:plistpath]) {
        plistpath = [[NSBundle mainBundle] pathForResource:@"selectCharacterView" ofType:@"plist"];
    }
    
    //查找strings.plist
    NSString *splistpath = [rootpath stringByAppendingPathComponent:@"strings.plist"];
    //如果未找到，则从bundle里查找
    if (![[NSFileManager defaultManager] fileExistsAtPath:splistpath]) {
        splistpath = [[NSBundle mainBundle] pathForResource:@"strings" ofType:@"plist"];
    }
    
    NSDictionary *layoutSettings = [NSDictionary dictionaryWithContentsOfFile:plistpath];
    NSDictionary *stringSettings = [NSDictionary dictionaryWithContentsOfFile:splistpath];

    
    int screenResolution = [[ShareGameObjectManager shareGameObjectManager] getScreenResolution];
    NSString* key = [NSString stringWithFormat:@"%d",screenResolution];
    
    NSDictionary* strings = [stringSettings objectForKey:key];
    
    NSArray* ar = [layoutSettings objectForKey:key];
    for (NSDictionary* item in ar) {
        NSNumber* childType = [item objectForKey:@"childType"];
        if ([childType integerValue] == 1) {
            //text value
            NSNumber* textID = [item objectForKey:@"textID"];
            NSString* textKey = [NSString stringWithFormat:@"%d",[textID integerValue]];
            NSString* text = [strings objectForKey:textKey];
            CCLabelBMFont* label = [CCLabelBMFont labelWithString:text fntFile:@"ninja-casual.fnt"];
            label.scale = 0.5f;
            NSNumber* xpos = [item objectForKey:@"x"];
            NSNumber* ypos = [item objectForKey:@"y"];
            label.position = ccp([xpos integerValue],[ypos integerValue]);
            NSNumber* itag = [item objectForKey:@"tag"];
            NSNumber* zpos = [item objectForKey:@"z"];
            if ([itag integerValue]>=221) {
                label.scale = 0.4f;
            }
            
            [self addChild:label z:[zpos integerValue] tag:[itag integerValue]];
            
        }
        else if ([childType integerValue] == 0) {
            //sprite value
            NSString* spritename = [item objectForKey:@"spriteName"];
            CCSprite* sprite = [CCSprite spriteWithFile:spritename];
            NSNumber* xpos = [item objectForKey:@"x"];
            NSNumber* ypos = [item objectForKey:@"y"];
            sprite.position = ccp([xpos integerValue],[ypos integerValue]);
            NSNumber* itag = [item objectForKey:@"tag"];
            NSNumber* zpos = [item objectForKey:@"z"];
            [self addChild:sprite z:[zpos integerValue] tag:[itag integerValue]];
        }
    }
    
}

//textID > 240 , defined in GameDefine.h
-(void) showMessageInDialog:(NSNumber*)textID // when switch character , show character info in dialog
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    [self unscheduleAllSelectors];
    int cid = [textID integerValue];
    //查找strings.plist
    NSString *rootpath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSString *splistpath = [rootpath stringByAppendingPathComponent:@"strings.plist"];
    //如果未找到，则从bundle里查找
    if (![[NSFileManager defaultManager] fileExistsAtPath:splistpath]) {
        splistpath = [[NSBundle mainBundle] pathForResource:@"strings" ofType:@"plist"];
    }
    
    NSDictionary *stringSettings = [NSDictionary dictionaryWithContentsOfFile:splistpath];
    int screenResolution = [[ShareGameObjectManager shareGameObjectManager] getScreenResolution];
    NSString* key = [NSString stringWithFormat:@"%d",screenResolution];
    
    NSDictionary* strings = [stringSettings objectForKey:key];
    NSString* msg = [strings objectForKey:[NSString stringWithFormat:@"%d",cid]];
    
    //CCLOG(@"message is : %@",msg);
    
    CCLabelBMFont* messages;
    CCNode* obj = [self getChildByTag:TEXT_MESSAGES];
    if (obj == nil) {
        //only first time into this view
    }
    else {
        messages = (CCLabelBMFont*)obj;
        [messages stopAllActions];
        [self unscheduleAllSelectors];
        [messages removeFromParentAndCleanup:YES];
    }
    
    messages = nil;
    messages = [CCLabelBMFont labelWithString:msg fntFile:@"ninja-casual.fnt"];
    messages.tag = TEXT_MESSAGES;
    messages.anchorPoint = ccp(0,0);
    messages.scale = 0.5f;
    messages.visible = YES;
    
    //todo: amend messages 's position
    CGSize size = [[CCDirector sharedDirector] winSize];
    CGPoint pos = self.position;
    if (pos.x == 0) {
        //first character
        messages.position = ccp(20,50);
    }
    else if (pos.x == -size.width) {
        //second character
        messages.position = ccp(340,50);
    }
    else if (pos.x == -size.width*2) {
        //third character
        messages.position = ccp(660,50);
    }
    
    for (CCNode *node in messages.children) {
        CCSprite *charSpr = (CCSprite *)node;
        charSpr.opacity = 0;
    }
    [self addChild: messages z:3];
    
    currentTextProcess = 0;
    maxTextProcess = [[messages children] count];
    [self schedule:@selector(updateText:) interval:0.02f];
    
}


-(void) updateText:(ccTime)delta
{
    CCNode* obj = [self getChildByTag:TEXT_MESSAGES];
    if (obj == nil)
    {
        [self unschedule:_cmd];
        return;
    }
    CCLabelBMFont* messages = (CCLabelBMFont*)obj;
    if (currentTextProcess<maxTextProcess) {
        CCSprite *t = (CCSprite*)[messages getChildByTag:currentTextProcess];
        t.opacity = 255;
        currentTextProcess++;
    }
    else {
        CCLOG(@"update text in dialog finish...");
        [self unschedule:_cmd];
    }
}

//进入下一个场景和返回上一个场景
-(void) gobackScene
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    [[ShareGameObjectManager shareGameObjectManager] runSceneWithID:SELECT_GAME_TYPE_SCENE withLoadingNextScene:0];
}

-(void) goNextScene
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    //set the character info into ShareGameManager
    CGSize size = [[CCDirector sharedDirector] winSize];
    CGPoint pos = self.position;
    if (pos.x == 0) {
        //first character
        [[ShareGameObjectManager shareGameObjectManager] setPlayerCharacterID:1];
    }
    else if (pos.x == -size.width) {
        //second character
        [[ShareGameObjectManager shareGameObjectManager] setPlayerCharacterID:2];
        
    }
    else if (pos.x == -size.width*2) {
        //third character
        [[ShareGameObjectManager shareGameObjectManager] setPlayerCharacterID:3];
    }

    [[ShareGameObjectManager shareGameObjectManager] runSceneWithID:SELECT_MAP_SCENE withLoadingNextScene:0];
}

-(int) checkCharacterViewPos
{
    CGSize size = [[CCDirector sharedDirector] winSize];
    CGPoint pos = self.position;
    if (pos.x == 0) {
        return 1;
    }
    else if (pos.x == -size.width) {
        return 2;
        
    }
    else if (pos.x == -size.width*2) {
        return 3;
    }
    else {
        return 1;
    }
}

@end
