//
//  SelectMapLayer.m
//  theLastNinja
//
//  Created by lai qing on 13-11-1.
//  Copyright 2013年 Tide Studio Game. All rights reserved.
//

#import "SelectMapLayer.h"


@implementation SelectMapLayer

-(id) init
{
    if( (self=[super init]) ) {
        [self loadSpriteAndLabelFromPlist];
        
    }
    return self;
}

-(int) leftButtonTouch
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    int result = 1;
    
    CGSize size = [[CCDirector sharedDirector] winSize];
    CGPoint pos = self.position;
    if (pos.x == 0) {
        result = 1;
        return result;
    }
    else if (pos.x == -size.width) {
        result = 1;
        
    }
    else if (pos.x == -size.width*2) {
        result = 2;
    }
    else if (pos.x == -size.width*3) {
        result = 3;
    }
    else if (pos.x == -size.width*4) {
        result = 4;
    }
    
    
    CGFloat xoffset =  size.width ;
    CCMoveBy* mv = [CCMoveBy actionWithDuration:0.2f position:ccp(xoffset,0)];
    //CCEaseInOut* rmv = [CCEaseInOut actionWithAction:mv];
    [self runAction:mv];
    
    
    return result;
    
}

-(int) rightButtonTouch
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    int result = 2;
    
    CGSize size = [[CCDirector sharedDirector] winSize];
    CGPoint pos = self.position;
    if (pos.x == 0) {
        result = 2;
    }
    else if (pos.x == -size.width) {
        result = 3;
        
    }
    else if (pos.x == -size.width*2) {
        result = 4;
    }
    else if (pos.x == -size.width*3) {
        result = 5;
    }
    else if (pos.x == -size.width*4) {
        result = 5;
        return result;
    }
    
    
    CGFloat xoffset =  -size.width ;
    CCMoveBy* mv = [CCMoveBy actionWithDuration:0.2f position:ccp(xoffset,0)];
    //CCEaseInOut* rmv = [CCEaseInOut actionWithAction:mv];
    [self runAction:mv];
    
    return result;
}

-(void) loadSpriteAndLabelFromPlist
{
    //从documents目录下进行查找plist
    NSString *rootpath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSString *plistpath = [rootpath stringByAppendingPathComponent:@"selectMapView.plist"];
    //如果未找到，则从bundle里查找
    if (![[NSFileManager defaultManager] fileExistsAtPath:plistpath]) {
        plistpath = [[NSBundle mainBundle] pathForResource:@"selectMapView" ofType:@"plist"];
    }
    
    //查找strings.plist
    NSString *splistpath = [rootpath stringByAppendingPathComponent:@"strings.plist"];
    //如果未找到，则从bundle里查找
    if (![[NSFileManager defaultManager] fileExistsAtPath:splistpath]) {
        splistpath = [[NSBundle mainBundle] pathForResource:@"strings" ofType:@"plist"];
    }
    
    NSDictionary *layoutSettings = [NSDictionary dictionaryWithContentsOfFile:plistpath];
    NSDictionary *stringSettings = [NSDictionary dictionaryWithContentsOfFile:splistpath];
    
    
    int screenResolution = [[ShareGameObjectManager shareGameObjectManager] getScreenResolution];
    NSString* key = [NSString stringWithFormat:@"%d",screenResolution];
    
    NSDictionary* strings = [stringSettings objectForKey:key];
    
    NSArray* ar = [layoutSettings objectForKey:key];
    for (NSDictionary* item in ar) {
        NSNumber* childType = [item objectForKey:@"childType"];
        if ([childType integerValue] == 1) {
            //text value
            NSNumber* textID = [item objectForKey:@"textID"];
            NSString* textKey = [NSString stringWithFormat:@"%d",[textID integerValue]];
            NSString* text = [strings objectForKey:textKey];
            CCLabelBMFont* label = [CCLabelBMFont labelWithString:text fntFile:@"ninja-casual.fnt"];
            //label.scale = 0.5f;
            NSNumber* xpos = [item objectForKey:@"x"];
            NSNumber* ypos = [item objectForKey:@"y"];
            label.position = ccp([xpos integerValue],[ypos integerValue]);
            NSNumber* itag = [item objectForKey:@"tag"];
            NSNumber* zpos = [item objectForKey:@"z"];
            
            [self addChild:label z:[zpos integerValue] tag:[itag integerValue]];
            
        }
        else if ([childType integerValue] == 0) {
            //sprite value
            NSString* spritename = [item objectForKey:@"spriteName"];
            CCSprite* sprite = [CCSprite spriteWithFile:spritename];
            NSNumber* xpos = [item objectForKey:@"x"];
            NSNumber* ypos = [item objectForKey:@"y"];
            sprite.position = ccp([xpos integerValue],[ypos integerValue]);
            NSNumber* itag = [item objectForKey:@"tag"];
            NSNumber* zpos = [item objectForKey:@"z"];
            [self addChild:sprite z:[zpos integerValue] tag:[itag integerValue]];
        }
    }
    
}


//进入下一个场景和返回上一个场景
-(void) gobackScene
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    [[ShareGameObjectManager shareGameObjectManager] goBackScene];
}

-(void) goNextScene
{
    if ([[ShareGameObjectManager shareGameObjectManager] getSound]) {
        [[ShareGameObjectManager shareGameObjectManager] playEffect:@"menutouch.caf"];
    }
    int gameSceneID = LANDSCRAPER_SCENE;
    int mapPos = [self checkViewPos];
    switch (mapPos) {
        case 1:
            gameSceneID = LANDSCRAPER_SCENE;
            break;
        case 2:
            gameSceneID = FOREST_SCENE;
            break;
        case 3:
            gameSceneID = ICEBERG_SCENE;
            break;
        case 4:
            gameSceneID = VOLCANO_SCENE;
            break;
        case 5:
            gameSceneID = BASE_SCENE;
            break;
        default:
            break;
    }
    [[ShareGameObjectManager shareGameObjectManager] runSceneWithID:LOADING_SCENE withLoadingNextScene:gameSceneID];
}

-(int) checkViewPos
{
    CGSize size = [[CCDirector sharedDirector] winSize];
    CGPoint pos = self.position;
    if (pos.x == 0) {
        return 1;
    }
    else if (pos.x == -size.width) {
        return 2;
        
    }
    else if (pos.x == -size.width*2) {
        return 3;
    }
    else if (pos.x == -size.width*3) {
        return 4;
    }
    else if (pos.x == -size.width*4) {
        return 5;
    }
    else {
        return 1;
    }
}

@end
