//
//  ShareGameObjectManager.h
//  JumpingElfin
//
//  Created by lai qing on 12-4-25.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "cocos2d.h"
#import "SimpleAudioEngine.h"
#import "GameDefine.h"
#import "SceneProtocol.h"


@interface ShareGameObjectManager : NSObject {
    int screenResolution;
    
    int useMusic;
    int useEffect;
    int showTutorial;
    int currentRecID;
    playerRecord currentRec;
    sceneRecord currentUnlockState;
    
    int recordLevel[3];
    int recordPlayerID[3];
    
    //当前scene id
    int currentSceneID;
    int preSceneID;
    
    //sound state
    BOOL hasAudioBeenInitialized;
    GameManagerSoundState managerSoundState;
    NSString* currentBackMusic;
    
    //current game score
    int jumpHighest;
    int killCount;
    
    //current game capture
    UIImage* screenShot;
    
    //CCLayer *gameLayer;
    //CCLayer *hudLayer;
    //CCLayer *backgroundLayer;
    CCArray *loadingAnimateList;
    CCArray *loadingSoundList;
}

+(id)shareGameObjectManager;

-(void) initGameLayer:(CCLayer*)g HUDLayer:(CCLayer*)h BGLayer:(CCLayer*)b;

-(void) initSpriteCCZIntoCache:(int)sceneID;

-(void)initAllAnimationInScene:(int)sceneID screenResolution:(int)screenID;

-(void)initAllSoundEffectInScene:(int)sceneID;

-(void)removeAnimateCache;

//-(void)removeSpriteCache;

-(void)removeSoundCache;

-(BOOL) findOutSaveRecord:(int)recid;
-(void) loadFileRecord;
-(void) setFileRecordID:(int)recid;
-(void) saveFileRecord:(int)recid;
-(void) initNewFileRecord:(int)recid;
-(void) setPlayerCharacterID:(int)player_id;
-(int) getPlayerLevelFromRecord:(int)recid;
-(int) getPlayerIDFromRecord:(int)recid;
-(void) deleteRecordFile:(int)recid;
-(void) copyPlayerRecordFromCCSprite:(playerRecord)pr;
-(playerRecord) getCurrentPlayerInfo;

-(void) saveFileRecordInInit;

//scene , characrer unlock
-(void) unlockCharacter:(int)character_id;
-(void) unlockScene:(int)scend_id;
-(void) saveToLockRecord;
-(void) loadFromLockRecord;

-(void) setMusic:(int)val;
-(void) setSound:(int)val;
-(void) setTurtorial:(int)val;
-(int) getMusic;
-(int) getSound;
-(int) getTutorial;

-(void) setScreenResolution:(int)sr;
-(int) getScreenResolution;

-(void) runSceneWithID:(int)sceneID withLoadingNextScene:(int)nextSceneID;
-(void) setCurrentSceneID:(int)sceneID;
-(void) goBackScene;

//以下需要加入初始化音乐的部分
-(void)setupAudioEngine;
-(ALuint)playSoundEffect:(NSString*)soundEffectName;
-(ALuint) playEffect:(NSString*)soundName;
-(void)stopSoundEffect:(ALuint)soundEffectID;
-(void)playBackgroundTrack:(NSString*)trackFileName;
-(void)initAudioAsync; //此方法在setupAudioEngine里用线程异步调用

//游戏中的分数增加
-(void) changeJumpHight:(int)height;
-(void) increaseKillCount;
-(void) resetJumpHeightAndKillCount;
-(void) resetScreenShot;
-(void) setScreenShot:(UIImage*)shot;
-(UIImage*) getScreenShot;

-(int) getJumpHeight;
-(int) getKillCount;

@end
