//
//  TouchAbleSprite.m
//  TouchCCSprite
//
//  Created by laiqing lai on 12-5-16.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import "TouchAbleSprite.h"


@implementation TouchAbleSprite

-(id)init {
    if ((self=[super init])) {
        touchID = 0;
    }
    return self;
}


-(void) initLayer:(CCLayer*)p withSelector:(SEL)selector defaultImageFile:(NSString*)defaultImage pressImageFile:(NSString*)pressedImage imageInCache:(BOOL)imgInCache
{
    parentLayer = p;
    callbackFunc = selector;
    defaultFileName = [defaultImage retain];
    pressedFileName = [pressedImage retain];
    imgInCache_ = imgInCache;
}

-(void)dealloc {
    [defaultFileName release];
    [pressedFileName release];
    [super dealloc];
}

-(void)onEnter {
    [[[CCDirector sharedDirector] touchDispatcher] addTargetedDelegate:self priority:0 swallowsTouches:YES];
    //[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:self priority:0 swallowsTouches:YES];
    [super onEnter];
}

-(void)onExit {	
    [[[CCDirector sharedDirector] touchDispatcher] removeDelegate:self];
    //[[CCTouchDispatcher sharedDispatcher] removeDelegate:self];
    [super onExit];
}

- (BOOL)containsTouchLocation:(UITouch *)touch  
{  
    CGPoint location = [touch locationInView:[touch view]];
	location = [[CCDirector sharedDirector] convertToGL:location];
    //
    return CGRectContainsPoint([self boundingBox], location);
    //[self convertTouchToNodeSpaceAR:touch]);
    //return CGRectContainsPoint(self.textureRect, [self convertTouchToNodeSpaceAR:touch]);
}

-(void) setTouchID:(int)tid
{
    touchID = tid;
}

- (BOOL)ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event {
    if ( ![self containsTouchLocation:touch] )   
    {  
        return NO;  
    }
    else {
        if (imgInCache_) {
            [self setDisplayFrame:[[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:pressedFileName]];
        }
        else {
            CCTexture2D *tex = [[CCTextureCache sharedTextureCache] addImage:pressedFileName];
            [self setTexture:tex];
        }
        return YES;
    }
}


- (void)ccTouchMoved:(UITouch *)touch withEvent:(UIEvent *)event {
    
}

- (void)ccTouchEnded:(UITouch *)touch withEvent:(UIEvent *)event {
    
    //CCLOG(@" touch end, try to combos...");
    if (imgInCache_) {
        [self setDisplayFrame:[[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:defaultFileName]];
    }
    else {
        CCTexture2D *tex = [[CCTextureCache sharedTextureCache] addImage:defaultFileName];
        [self setTexture:tex];
    }
    
    //int state = [_parent getPlayerState];
    
    //if (state == PLAYER_ATTACK_STATE) return;
    
    //else
    if (touchID == 0 )
    {
        if ([_parent respondsToSelector:callbackFunc]) {
            [_parent performSelector:callbackFunc];
        }
    }
    else
    {
        if ([_parent respondsToSelector:callbackFunc]) {
            [_parent performSelector:callbackFunc withObject:[NSNumber numberWithInt:touchID]];
        }
    }
    
    //[_parent playerFire];

}

- (void)ccTouchCancelled:(UITouch *)touch withEvent:(UIEvent *)event {
    
}

@end
